Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices

'//////////////////////////////////////////////////////////////
''' <summary>
''' DirectShowp̃[eBeBW[(O֌W)łB
''' </summary>
''' <remarks></remarks>
Public Module DSUtilityException

    ''' <summary>
    ''' DirectShow[eBeBp̗ONXłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Class DSException
        Inherits Exception

#Region "RXgN^"

        ''' <summary>
        ''' bZ[Ww肵ADirectShow[eBeBONX܂B
        ''' </summary>
        ''' <param name="Msg">bZ[W</param>
        ''' <param name="Param">bZ[W</param>
        ''' <remarks></remarks>
        Public Sub New(ByVal Msg As String, ByVal ParamArray Param() As Object)
            MyBase.New(CreateMessage(Msg, Param))
        End Sub

        ''' <summary>
        ''' Ow肵ADirectShow[eBeBONX܂B
        ''' </summary>
        ''' <param name="ex">ɂȂO</param>
        ''' <param name="Msg">bZ[W</param>
        ''' <param name="Param">bZ[W</param>
        ''' <remarks></remarks>
        Public Sub New(ByVal ex As Exception, ByVal Msg As String, ByVal ParamArray Param() As Object)
            MyBase.New(CreateMessage(Msg, Param), CreateInnerException(ex))
        End Sub

        ''' <summary>
        ''' COMExceptionOw肵ADirectShow[eBeBONX܂B
        ''' </summary>
        ''' <param name="ex">ɂȂCOMExceptionO</param>
        ''' <param name="Msg">bZ[W</param>
        ''' <param name="Param">bZ[W</param>
        ''' <remarks></remarks>
        Public Sub New(ByVal ex As COMException, ByVal Msg As String, ByVal ParamArray Param() As Object)
            MyBase.New(CreateMessage(Msg, Param), ex)
        End Sub


        ''' <summary>
        ''' G[bZ[W𐶐܂B       
        ''' </summary>
        ''' <param name="Fmt">bZ[W</param>
        ''' <param name="Param">bZ[W</param>
        ''' <returns>bZ[W</returns>
        ''' <remarks></remarks>
        Private Shared Function CreateMessage(ByVal Fmt As String, ByRef Param() As Object) As String

            Dim msg As String
            Try
                msg = String.Format(Fmt, Param)
            Catch ex As Exception
                Fmt = Fmt.Replace("{", "{{")
                Fmt = Fmt.Replace("}", "}}")
                msg = String.Format(Fmt, Param)
            End Try

            Return msg
        End Function

        ''' <summary>
        ''' ɂȂOC܂B
        ''' </summary>
        ''' <param name="ex">̗O</param>
        ''' <returns>CꂽO</returns>
        ''' <remarks></remarks>
        Private Shared Function CreateInnerException(ByVal ex As Exception) As Exception

            'COMException̏ꍇAǉ̗Oǉ
            If TypeOf ex Is COMException Then

                'COMException擾
                Dim comex As COMException = CType(ex, COMException)

                'bZ[W
                Dim msg As String = GetDirectShowMessage(comex.ErrorCode)

                'G[R[h
                Dim hr As DirectShowHRESULT = CType(comex.ErrorCode, DirectShowHRESULT)
                Dim cname As String = hr.ToString
                If hr.ToString <> comex.ErrorCode.ToString Then msg += "(" + cname + ")"

                'Ώۃ\bh
                msg += " @ " + comex.TargetSite.ToString

                Return New DSException(comex, msg)
            End If

            '̂܂
            Return ex
        End Function

#End Region

#Region "擾"

        ''' <summary>
        ''' O̗R܂ށAO擾܂B
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Function FullMessage() As String

            Dim msg As New System.Text.StringBuilder()
            msg.AppendLine(Me.Message)
            Dim ex As Exception = Me.InnerException
            Do While ex IsNot Nothing
                msg.AppendLine("RF" + ex.Message)
                ex = ex.InnerException
            Loop

            Return msg.ToString
        End Function

#End Region

    End Class

    ''' <summary>
    ''' DirectShow֘ÃG[bZ[W擾܂B
    ''' </summary>
    ''' <param name="ResultCode">^[R[h</param>
    ''' <returns>^[R[hɑΉbZ[W</returns>
    ''' <remarks></remarks>
    Public Function GetDirectShowMessage(ByVal ResultCode As Integer) As String
        Return GetDirectShowMessage(CType(ResultCode, DirectShowHRESULT))
    End Function

    ''' <summary>
    ''' DirectShow֘ÃG[bZ[W擾܂B
    ''' </summary>
    ''' <param name="ResultCode">^[R[h</param>
    ''' <returns>^[R[hɑΉbZ[W</returns>
    ''' <remarks></remarks>
    Public Function GetDirectShowMessage(ByVal ResultCode As DirectShowHRESULT) As String
        Dim mes As String

        Select Case ResultCode
            Case DirectShowHRESULT.VFW_E_INVALIDMEDIATYPE : mes = "w肳ꂽfBA ^Cv͖łB"        '= &H80040200
            Case DirectShowHRESULT.VFW_E_INVALIDSUBTYPE : mes = "w肳ꂽfBA Tu^Cv͖łB"      '= &H80040201
            Case DirectShowHRESULT.VFW_E_NEED_OWNER : mes = "̃IuWFNg͏WIuWFNgƂĂ̂ݍ쐬łB"        '= &H80040202
            Case DirectShowHRESULT.VFW_E_ENUM_OUT_OF_SYNC : mes = "񋓃IuWFNg̏ԂωāA񋓎q̏ԂƂ̖B"       '= &H80040203
            Case DirectShowHRESULT.VFW_E_ALREADY_CONNECTED : mes = "Ɋ܂܂sɏȂƂ 1 ڑĂB"       '= &H80040204
            Case DirectShowHRESULT.VFW_E_FILTER_ACTIVE : mes = "tB^ANeBuȂ̂ŁȀsłȂB"      '= &H80040205
            Case DirectShowHRESULT.VFW_E_NO_TYPES : mes = "w肳ꂽꂩ̃sfBA ^CvT|[gĂȂB"        '= &H80040206
            Case DirectShowHRESULT.VFW_E_NO_ACCEPTABLE_TYPES : mes = "̃sɋʂ̃fBA ^CvȂB"      '= &H80040207
            Case DirectShowHRESULT.VFW_E_INVALID_DIRECTION : mes = "̃s 2 ڑ邱Ƃ͂łȂB"        '= &H80040208
            Case DirectShowHRESULT.VFW_E_NOT_CONNECTED : mes = "sڑĂȂ߁AsłȂB"        '= &H80040209
            Case DirectShowHRESULT.VFW_E_NO_ALLOCATOR : mes = "Tv obt@ AP[^ps\B"      '= &H8004020A
            Case DirectShowHRESULT.VFW_E_RUNTIME_ERROR : mes = "sG[B"        '= &H8004020B
            Case DirectShowHRESULT.VFW_E_BUFFER_NOTSET : mes = "obt@Ԃݒ肳ĂȂB"        '= &H8004020C
            Case DirectShowHRESULT.VFW_E_BUFFER_OVERFLOW : mes = "obt@̑傫ȂB"      '= &H8004020D
            Case DirectShowHRESULT.VFW_E_BADALIGN : mes = "ȃACgw肳ꂽB"       '= &H8004020E
            Case DirectShowHRESULT.VFW_E_ALREADY_COMMITTED : mes = "AP[^̓R~bgȂBuIMemAllocator::CommitvQƂ邱ƁB"        '= &H8004020F
            Case DirectShowHRESULT.VFW_E_BUFFERS_OUTSTANDING : mes = "1 ܂͕̃obt@ANeBułB"     '= &H80040210
            Case DirectShowHRESULT.VFW_E_NOT_COMMITTED : mes = "AP[^ANeBułȂƂ̓Tv蓖Ă邱ƂłȂB"     '= &H80040211
            Case DirectShowHRESULT.VFW_E_SIZENOTSET : mes = "TCYݒ肳ĂȂ̂ŁA蓖Ă邱ƂłȂB"        '= &H80040212
            Case DirectShowHRESULT.VFW_E_NO_CLOCK : mes = "NbN`ĂȂ̂ŁAsȂB"        '= &H80040213
            Case DirectShowHRESULT.VFW_E_NO_SINK : mes = "iVN`ĂȂ̂ŁAibZ[W𑗐MłȂB"        '= &H80040214
            Case DirectShowHRESULT.VFW_E_NO_INTERFACE : mes = "KvȃC^[tFCXĂȂB"       '= &H80040215
            Case DirectShowHRESULT.VFW_E_NOT_FOUND : mes = "IuWFNg܂͖OȂB"       '= &H80040216
            Case DirectShowHRESULT.VFW_E_CANNOT_CONNECT : mes = "ڑm钆ԃtB^̑gݍ킹ȂB"       '= &H80040217
            Case DirectShowHRESULT.VFW_E_CANNOT_RENDER : mes = "Xg[_OtB^̑gݍ킹ȂB"      '= &H80040218
            Case DirectShowHRESULT.VFW_E_CHANGING_FORMAT : mes = "tH[}bg𓮓IɕύXłȂB"       '= &H80040219
            Case DirectShowHRESULT.VFW_E_NO_COLOR_KEY_SET : mes = "J[ L[ݒ肳ĂȂB"        '= &H8004021A
            Case DirectShowHRESULT.VFW_E_NOT_OVERLAY_CONNECTION : mes = "݂̃sڑ IOverlay ]gĂȂB"        '= &H8004021B
            Case DirectShowHRESULT.VFW_E_NOT_SAMPLE_CONNECTION : mes = "݂̃sڑ IMemInputPin ]gĂȂB"        '= &H8004021C
            Case DirectShowHRESULT.VFW_E_PALETTE_SET : mes = "J[ L[ݒ肷ƁAɐݒ肳ĂpbgƖ\B"      '= &H8004021D
            Case DirectShowHRESULT.VFW_E_COLOR_KEY_SET : mes = "pbgݒ肷ƁAɐݒ肳ĂJ[ L[Ɩ\B"      '= &H8004021E
            Case DirectShowHRESULT.VFW_E_NO_COLOR_KEY_FOUND : mes = "vJ[ L[ȂB"      '= &H8004021F
            Case DirectShowHRESULT.VFW_E_NO_PALETTE_AVAILABLE : mes = "pbgps\B"     '= &H80040220
            Case DirectShowHRESULT.VFW_E_NO_DISPLAY_PALETTE : mes = "fBXvC̓pbggȂB"       '= &H80040221
            Case DirectShowHRESULT.VFW_E_TOO_MANY_COLORS : mes = "݂̃fBXvCݒɑ΂ĐFB"      '= &H80040222
            Case DirectShowHRESULT.VFW_E_STATE_CHANGED : mes = "Tv̏҂ĂԂɏԂωB"     '= &H80040223
            Case DirectShowHRESULT.VFW_E_NOT_STOPPED : mes = "tB^~ĂȂ̂ŁAsłȂB"       '= &H80040224
            Case DirectShowHRESULT.VFW_E_NOT_PAUSED : mes = "tB^~ĂȂ߁AsłȂB"     '= &H80040225
            Case DirectShowHRESULT.VFW_E_NOT_RUNNING : mes = "tB^sĂȂ̂ŁAsłȂB"      '= &H80040226
            Case DirectShowHRESULT.VFW_E_WRONG_STATE : mes = "tB^sȏԂɂ邽߁AsłȂB"        '= &H80040227
            Case DirectShowHRESULT.VFW_E_START_TIME_AFTER_END : mes = "Tv̊Jn^CTv̏I^ČɂȂĂB"      '= &H80040228
            Case DirectShowHRESULT.VFW_E_INVALID_RECT : mes = "񋟂ꂽ`łB"      '= &H80040229
            Case DirectShowHRESULT.VFW_E_TYPE_NOT_ACCEPTED : mes = "̃śA񋟂ꂽfBA ^CvgȂB"       '= &H8004022A
            Case DirectShowHRESULT.VFW_E_SAMPLE_REJECTED : mes = "̃Tv̓_OłȂB"      '= &H8004022B
            Case DirectShowHRESULT.VFW_E_SAMPLE_REJECTED_EOS : mes = "Xg[̏IɓBĂ̂ŁÃTv_OłȂB"       '= &H8004022C
            Case DirectShowHRESULT.VFW_E_DUPLICATE_NAME : mes = "ÕtB^ǉ悤ƂsB"        '= &H8004022D
            Case DirectShowHRESULT.VFW_S_DUPLICATE_NAME : mes = "ÕtB^ǉ悤ƂƂAOύXďB"       '= &H4022D   
            Case DirectShowHRESULT.VFW_E_TIMEOUT : mes = "^CAEgԂ߂B"       '= &H8004022E
            Case DirectShowHRESULT.VFW_E_INVALID_FILE_FORMAT : mes = "t@C tH[}bgłB"      '= &H8004022F
            Case DirectShowHRESULT.VFW_E_ENUM_OUT_OF_RANGE : mes = "XggʂꂽB"        '= &H80040230
            Case DirectShowHRESULT.VFW_E_CIRCULAR_GRAPH : mes = "tB^ OtzĂB"        '= &H80040231
            Case DirectShowHRESULT.VFW_E_NOT_ALLOWED_TO_SAVE : mes = "̏Ԃł̍XV͋ȂB"     '= &H80040232
            Case DirectShowHRESULT.VFW_E_TIME_ALREADY_PASSED : mes = "ߋ̃^C̃R}hL[ɓ悤ƂB"        '= &H80040233
            Case DirectShowHRESULT.VFW_E_ALREADY_CANCELLED : mes = "L[ɓꂽR}h͊ɃLZĂB"     '= &H80040234
            Case DirectShowHRESULT.VFW_E_CORRUPT_GRAPH_FILE : mes = "t@CĂ̂Ń_OłȂB"     '= &H80040235
            Case DirectShowHRESULT.VFW_E_ADVISE_ALREADY_SET : mes = "IOverlay AhoCY Nɑ݂ĂB"        '= &H80040236
            Case DirectShowHRESULT.VFW_S_STATE_INTERMEDIATE : mes = "Ԃ̈ڍsĂȂB"      '= &H40237   
            Case DirectShowHRESULT.VFW_E_NO_MODEX_AVAILABLE : mes = "tXN[ [h͗płȂB"     '= &H80040238
            Case DirectShowHRESULT.VFW_E_NO_ADVISE_SET : mes = "̃AhoCY͐ɐݒ肳ĂȂ̂ŃLZłȂB"     '= &H80040239
            Case DirectShowHRESULT.VFW_E_NO_FULLSCREEN : mes = "tXN[ [h͗płȂB"     '= &H8004023A
            Case DirectShowHRESULT.VFW_E_IN_FULLSCREEN_MODE : mes = "tXN[ [hł IVideoWindow \bhĂяoȂB"     '= &H8004023B
            Case DirectShowHRESULT.VFW_E_UNKNOWN_FILE_TYPE : mes = "̃t@C̃fBA ^CvFȂB"     '= &H80040240
            Case DirectShowHRESULT.VFW_E_CANNOT_LOAD_SOURCE_FILTER : mes = "̃t@C̃\[X tB^[hłȂB"        '= &H80040241
            Case DirectShowHRESULT.VFW_S_PARTIAL_RENDER : mes = "̃[r[ɃT|[gȂtH[}bg̃Xg[܂܂ĂB"     '= &H40242   
            Case DirectShowHRESULT.VFW_E_FILE_TOO_SHORT : mes = "t@CsSłB"        '= &H80040243
            Case DirectShowHRESULT.VFW_E_INVALID_FILE_VERSION : mes = "t@C̃o[WԍłB"     '= &H80040244
            Case DirectShowHRESULT.VFW_S_SOME_DATA_IGNORED : mes = "t@Cɂ̎gpĂȂvpeBݒ肪܂܂ĂB"       '= &H40245   
            Case DirectShowHRESULT.VFW_S_CONNECTIONS_DEFERRED : mes = "ꕔ̐ڑsĒxB"     '= &H40246   
            Case DirectShowHRESULT.VFW_E_INVALID_CLSID : mes = "̃t@C͉ĂBȃNXʎq܂܂ĂB"      '= &H80040247
            Case DirectShowHRESULT.VFW_E_INVALID_MEDIA_TYPE : mes = "̃t@C͉ĂBȃfBA ^Cv܂܂ĂB"        '= &H80040248
            Case DirectShowHRESULT.VFW_E_SAMPLE_TIME_NOT_SET : mes = "̃Tvɂ̓^C X^vݒ肳ĂȂB"      '= &H80040249
            Case DirectShowHRESULT.VFW_S_RESOURCE_NOT_NEEDED : mes = "w肳ꂽ\[X͂͂KvȂB"      '= &H40250   
            Case DirectShowHRESULT.VFW_E_MEDIA_TIME_NOT_SET : mes = "̃Tvɂ̓fBA ^Cݒ肳ĂȂB"      '= &H80040251
            Case DirectShowHRESULT.VFW_E_NO_TIME_FORMAT_SET : mes = "fBA ^C tH[}bgIĂȂB"       '= &H80040252
            Case DirectShowHRESULT.VFW_E_MONO_AUDIO_HW : mes = "I[fBI foCXmpȂ̂ŁAoXύXłȂB"       '= &H80040253
            Case DirectShowHRESULT.VFW_S_MEDIA_TYPE_IGNORED : mes = "iOt̃fBA ^CvɐڑłȂB"      '= &H40254   
            Case DirectShowHRESULT.VFW_E_NO_DECOMPRESSOR : mes = "rfI Xg[ĐłȂBK؂ȃfRvbTȂB"       '= &H80040255
            Case DirectShowHRESULT.VFW_E_NO_AUDIO_HARDWARE : mes = "I[fBI Xg[ĐłȂBI[fBI n[hEFApłȂA܂̓n[hEFAT|[gĂȂB"        '= &H80040256
            Case DirectShowHRESULT.VFW_S_VIDEO_NOT_RENDERED : mes = "rfI Xg[ĐłȂBK؂ȃ_ȂB"      '= &H40257   
            Case DirectShowHRESULT.VFW_S_AUDIO_NOT_RENDERED : mes = "I[fBI Xg[ĐłȂBK؂ȃ_ȂB"        '= &H40258   
            Case DirectShowHRESULT.VFW_E_RPZA : mes = "rfI Xg[ĐłȂBtH[}bg 'RPZA' ̓T|[gĂȂB"     '= &H80040259
            Case DirectShowHRESULT.VFW_S_RPZA : mes = "rfI Xg[ĐłȂBtH[}bg 'RPZA' ̓T|[gĂȂB"     '= &H4025A   
            Case DirectShowHRESULT.VFW_E_PROCESSOR_NOT_SUITABLE : mes = "DirectShow ͂̃vZbT MPEG [r[ĐłȂB"     '= &H8004025B
            Case DirectShowHRESULT.VFW_E_UNSUPPORTED_AUDIO : mes = "I[fBI Xg[ĐłȂB̃I[fBI tH[}bg̓T|[gĂȂB"       '= &H8004025C
            Case DirectShowHRESULT.VFW_E_UNSUPPORTED_VIDEO : mes = "rfI Xg[ĐłȂB̃rfI tH[}bg̓T|[gĂȂB"       '= &H8004025D
            Case DirectShowHRESULT.VFW_E_MPEG_NOT_CONSTRAINED : mes = "̃rfI Xg[͋KiɏĂȂ̂ DirectShow ōĐłȂB"        '= &H8004025E
            Case DirectShowHRESULT.VFW_E_NOT_IN_GRAPH : mes = "tB^ Otɑ݂ȂIuWFNgɗvꂽ֐słȂB"        '= &H8004025F
            Case DirectShowHRESULT.VFW_S_ESTIMATED : mes = "Ԃꂽl͗\lłBl̐mۏ؂łȂB"      '= &H40260   
            Case DirectShowHRESULT.VFW_E_NO_TIME_FORMAT : mes = "IuWFNg̃^C tH[}bgɃANZXłȂB"     '= &H80040261
            Case DirectShowHRESULT.VFW_E_READ_ONLY : mes = "Xg[ǂݏopŁAtB^ɂăf[^ύXĂ̂ŁAڑmłȂB"      '= &H80040262
            Case DirectShowHRESULT.VFW_S_RESERVED : mes = "̐R[h́ADirectShow ̓pɗ\񂳂ĂB"     '= &H40263   
            Case DirectShowHRESULT.VFW_E_BUFFER_UNDERFLOW : mes = "obt@\ɖĂȂB"       '= &H80040264
            Case DirectShowHRESULT.VFW_E_UNSUPPORTED_STREAM : mes = "t@CĐłȂBtH[}bgT|[gĂȂB"      '= &H80040265
            Case DirectShowHRESULT.VFW_E_NO_TRANSPORT : mes = "]T|[gĂȂ̂ŃsǂڑłȂB"       '= &H80040266
            Case DirectShowHRESULT.VFW_S_STREAM_OFF : mes = "Xg[ItɂȂB"       '= &H40267   
            Case DirectShowHRESULT.VFW_S_CANT_CUE : mes = "tB^̓ANeBuAf[^o͂邱ƂłȂBuIMediaFilter::GetStatevQƂ邱ƁB"       '= &H40268   
            Case DirectShowHRESULT.VFW_E_BAD_VIDEOCD : mes = "foCXrfI CD 𐳏ɓǂݏoȂA܂̓rfI CD ̃f[^ĂB"        '= &H80040269
            Case DirectShowHRESULT.VFW_S_NO_STOP_TIME : mes = "TvɏI^Cł͂ȂJn^Cݒ肳ĂB̏ꍇAԂI^C͊Jn^C 1 lɐݒ肳B"        '= &H80040270
            Case DirectShowHRESULT.VFW_E_OUT_OF_VIDEO_MEMORY : mes = "̃fBXvC𑜓xƐFɑ΂ărfI s\łB𑜓xႭƂ悢B"       '= &H80040271
            Case DirectShowHRESULT.VFW_E_VP_NEGOTIATION_FAILED : mes = "rfI |[gڑlSVG[V vZXsB"        '= &H80040272
            Case DirectShowHRESULT.VFW_E_DDRAW_CAPS_NOT_SUITABLE : mes = "Microsoft DirectDraw CXg[ĂȂA܂̓rfI J[h̔\͂K؂łȂBfBXvC 16 F[hłȂƂmF邱ƁB"     '= &H80040273
            Case DirectShowHRESULT.VFW_E_NO_VP_HARDWARE : mes = "rfI |[g n[hEFApłȂA܂̓n[hEFAȂB"      '= &H80040274
            Case DirectShowHRESULT.VFW_E_NO_CAPTURE_HARDWARE : mes = "Lv` n[hEFApłȂA܂̓n[hEFAȂB"        '= &H80040275
            Case DirectShowHRESULT.VFW_E_DVD_OPERATION_INHIBITED : mes = "̎_ł̃[U[ DVD Recɂċ֎~ĂB"        '= &H80040276
            Case DirectShowHRESULT.VFW_E_DVD_INVALIDDOMAIN : mes = "݂̃hCł̏͋ĂȂB"      '= &H80040277
            Case DirectShowHRESULT.VFW_E_DVD_NO_BUTTON : mes = "vꂽ{^płȂB"        '= &H80040278
            Case DirectShowHRESULT.VFW_E_DVD_GRAPHNOTREADY : mes = "DVD-Video ĐOt쐬ĂȂB"       '= &H80040279
            Case DirectShowHRESULT.VFW_E_DVD_RENDERFAIL : mes = "DVD-Video ĐOt̍쐬sB"        '= &H8004027A
            Case DirectShowHRESULT.VFW_E_DVD_DECNOTENOUGH : mes = "fR[_s\߂ɁADVD-Video ĐOt쐬łȂB"        '= &H8004027B

            Case DirectShowHRESULT.VFW_E_DDRAW_VERSION_NOT_SUITABLE : mes = "Version number of DirectDraw not suitable. Make sure to install dx5 or higher version.%0" '= &H8004027C   
            Case DirectShowHRESULT.VFW_E_COPYPROT_FAILED : mes = "Copy protection cannot be enabled. Please make sure any other copy protected content is not being shown now.%0" '= &H8004027D              
            Case DirectShowHRESULT.VFW_S_NOPREVIEWPIN : mes = "There was no preview pin available, so the capture pin output is being split to provide both capture and preview.%0" '= &H4027E                    
            Case DirectShowHRESULT.VFW_E_TIME_EXPIRED : mes = "This object cannot be used anymore as its time has expired.%0" '= &H8004027F                 
            Case DirectShowHRESULT.VFW_S_DVD_NON_ONE_SEQUENTIAL : mes = "The current title was not a sequential set of chapters (PGC), and the returned timing information might not be continuous.%0" '= &H40280          
            Case DirectShowHRESULT.VFW_E_DVD_WRONG_SPEED : mes = "The operation cannot be performed at the current playback speed.%0" '= &H80040281              
            Case DirectShowHRESULT.VFW_E_DVD_MENU_DOES_NOT_EXIST : mes = "The specified menu doesn't exist.%0" '= &H80040282      
            Case DirectShowHRESULT.VFW_E_DVD_CMD_CANCELLED : mes = "The specified command was either cancelled or no longer exists.%0" '= &H80040283            
            Case DirectShowHRESULT.VFW_E_DVD_STATE_WRONG_VERSION : mes = "The data did not contain a recognized version.%0" '= &H80040284      
            Case DirectShowHRESULT.VFW_E_DVD_STATE_CORRUPT : mes = "The state data was corrupt.%0" '= &H80040285            
            Case DirectShowHRESULT.VFW_E_DVD_STATE_WRONG_DISC : mes = "The state data is from a different disc.%0" '= &H80040286         
            Case DirectShowHRESULT.VFW_E_DVD_INCOMPATIBLE_REGION : mes = "The region was not compatible with the current drive.%0" '= &H80040287      
            Case DirectShowHRESULT.VFW_E_DVD_NO_ATTRIBUTES : mes = "The requested DVD stream attribute does not exist.%0" '= &H80040288            
            Case DirectShowHRESULT.VFW_E_DVD_NO_GOUP_PGC : mes = "Currently there is no GoUp (Annex J user function) program chain (PGC).%0" '= &H80040289              
            Case DirectShowHRESULT.VFW_E_DVD_LOW_PARENTAL_LEVEL : mes = "The current parental level was too low.%0" '= &H8004028A       
            Case DirectShowHRESULT.VFW_E_DVD_NOT_IN_KARAOKE_MODE : mes = "DVD irQ[^̓JIP [hł͂ȂB" '= &H8004028B      
            Case DirectShowHRESULT.VFW_S_DVD_CHANNEL_CONTENTS_NOT_AVAILABLE : mes = "The audio stream did not contain sufficient information to determine the contents of each channel.%0" '= &H4028C  
            Case DirectShowHRESULT.VFW_S_DVD_NOT_ACCURATE : mes = "The seek into the movie was not frame accurate.%0" '= &H4028D                
            Case DirectShowHRESULT.VFW_E_FRAME_STEP_UNSUPPORTED : mes = "R}̓T|[gĂȂB" '= &H8004028E       
            Case DirectShowHRESULT.VFW_E_DVD_STREAM_DISABLED : mes = "The specified stream is disabled and cannot be selected.%0" '= &H8004028F          
            Case DirectShowHRESULT.VFW_E_DVD_TITLE_UNKNOWN : mes = "The operation depends on the current title number, however the navigator has not yet entered the VTSM or the title domains," '= &H80040290            
            Case DirectShowHRESULT.VFW_E_DVD_INVALID_DISC : mes = "The specified path does not point to a valid DVD disc.%0" '= &H80040291             
            Case DirectShowHRESULT.VFW_E_DVD_NO_RESUME_INFORMATION : mes = "There is currently no resume information.%0" '= &H80040292    
            Case DirectShowHRESULT.VFW_E_PIN_ALREADY_BLOCKED_ON_THIS_THREAD : mes = "s͊ɌĂяõXbhŃubNĂB" '= &H80040293   
            Case DirectShowHRESULT.VFW_E_PIN_ALREADY_BLOCKED : mes = "s͊ɑ̃XbhŃubNĂB" '= &H80040294          
            Case DirectShowHRESULT.VFW_E_CERTIFICATION_FAILURE : mes = "̃tB^̎gṕA\tgEFA L[ɂĐĂBAvP[V́AtB^̃bNȂ΂ȂȂB" '= &H80040295        
            Case DirectShowHRESULT.VFW_E_VMR_NOT_IN_MIXER_MODE : mes = "The VMR has not yet created a mixing component.  That is, IVMRFilterConfig::SetNumberofStreams has not yet been called.%0" '= &H80040296        
            Case DirectShowHRESULT.VFW_E_VMR_NO_AP_SUPPLIED : mes = "The application has not yet provided the VMR filter with a valid allocator-presenter object.%0" '= &H80040297           
            Case DirectShowHRESULT.VFW_E_VMR_NO_DEINTERLACE_HW : mes = "The VMR could not find any de-interlacing hardware on the current display device.%0" '= &H80040298        
            Case DirectShowHRESULT.VFW_E_VMR_NO_PROCAMP_HW : mes = "The VMR could not find any ProcAmp hardware on the current display device.%0" '= &H80040299            
            Case DirectShowHRESULT.VFW_E_DVD_VMR9_INCOMPATIBLEDEC : mes = "VMR9 does not work with VPE-based hardware decoders.%0" '= &H8004029A     
            Case DirectShowHRESULT.VFW_E_BAD_KEY : mes = "WXg GgĂB" '= &H800403F2                      
            Case DirectShowHRESULT.E_PROP_SET_UNSUPPORTED : mes = "The Specified property set is not supported.%0" '= &H80070492             
            Case DirectShowHRESULT.E_PROP_ID_UNSUPPORTED : mes = "The specified property ID is not supported for the specified property set.%0" '= &H80070490             '  

            Case DirectShowHRESULT.E_NOTIMPL : mes = "Ă܂B"
            Case DirectShowHRESULT.E_OUTOFMEMORY : mes = "܂B"
            Case DirectShowHRESULT.E_INVALIDARG : mes = "słB"
            Case DirectShowHRESULT.E_NOINTERFACE : mes = "C^[tF[X܂B"
            Case DirectShowHRESULT.E_POINTER : mes = "NULL|C^Ɏw肳܂B"
            Case DirectShowHRESULT.E_HANDLE : mes = "sȃnhłB"
            Case DirectShowHRESULT.E_ABORT : mes = "삪~܂B"
            Case DirectShowHRESULT.E_FAIL : mes = "s܂B"
            Case DirectShowHRESULT.E_ACCESSDENIED : mes = "ANZX͋ۂ܂B"
            Case DirectShowHRESULT.S_OK : mes = ""
            Case Else
                mes = "sȃG[łB(" + Hex$(ResultCode) + ")"
        End Select

        Return mes
    End Function

End Module
