Option Explicit On
Option Strict On

'//////////////////////////////////////////////////////////////
'DShowLib@Tv@SoundWave
'Et@CĐȂA݈ʒu̔g`\TvłB
'E񈳏kWavet@CłȂAMP3Ȃǂ̈kꂽt@Cł\łB
'EPȔg`łȂADCTɂēg\邱Ƃł܂B
'//////////////////////////////////////////////////////////////

'DirectShowNXCu
Imports DShowLib

Public Class Form1

    '萔
    Private Const BUFFERINGTIME As Integer = 3      'g`ۑpobt@̃obt@O
    Private Const SAMPLECOUNT As Integer = 512      'xɎog`f[^

    'W[ϐ
    Private mGrp As IGraphBuilder       'Otr_(Ot\zp)
    Private mCtl As IMediaControl       'IMediaControlC^[tF[X(Otp)
    Private mPos As IMediaPosition      'IMediaPositionC^[tF[X(Đʒu擾p)
    Private mSmp As ISampleGrabber      'ISampleGrabberC^[tF[X(g`擾p)
    Private mFmt As DSWAVEFORMATEX      'g`
    Private mBuff As WaveBuffer         'g`ۑpobt@

    Private mWave(SAMPLECOUNT - 1) As WaveData      'og`f[^

    '----------------------------------------------------------

    'tH[[h
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'g``pC[W
        Pic_View.Image = New Bitmap(Pic_View.Width, Pic_View.Height)

    End Sub

    'tH[N[Y
    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'Ot̔j
        DestroyGraph()

    End Sub

    'Open{^
    Private Sub Btn_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Open.Click

        '^C}[~
        Timer_Draw.Enabled = False

        't@C擾
        Dim fname As String = Txt_Filename.Text

        Try

            'Ot\z
            CreateGraph(fname)

        Catch ex As DSException

            'Ot\zs
            MsgBox(ex.FullMessage)

        End Try

    End Sub

    'Play{^
    Private Sub Btn_Play_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Play.Click

        'ԃ`FbN
        If mPos Is Nothing Then Exit Sub
        If mCtl Is Nothing Then Exit Sub

        'obt@NA
        mBuff.ClearData()

        '߂
        mPos.put_CurrentPosition(0)

        'Đ
        mCtl.Run()

        '^C}[Jn
        Timer_Draw.Enabled = True

    End Sub

    'Stop{^
    Private Sub Btn_Stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Stop.Click

        'ԃ`FbN
        If mCtl Is Nothing Then Exit Sub

        '^C}[~
        Timer_Draw.Enabled = False

        '~
        mCtl.Stop()

    End Sub

    '----------------------------------------------------------

    'Ot\z
    Private Sub CreateGraph(ByVal Filename As String)

        'Ot̔j
        DestroyGraph()

        Try
            'Otr_
            mGrp = DSUtility.CreateNewGraph()

            'TvOotB^C^X
            Dim smpflt As IBaseFilter = DSUtility.CreateFilter(FilterGUID.CLSID_SampleGrabber)

            'ISampleGrabberC^[tF[X擾
            mSmp = CType(smpflt, ISampleGrabber)

            'TvOotB^̐ݒ
            Dim mt As New AM_MEDIA_TYPE
            mt.majorType = New Guid(MediaTypeGUID.MEDIATYPE_Audio)  '
            mt.subType = New Guid(MediaTypeGUID.MEDIASUBTYPE_PCM)   'PCM`
            mSmp.SetMediaType(mt)

            'TvOotB^Otɒǉ
            mGrp.AddFilter(smpflt, "SampleGrabber")

            'tB^A
            mGrp.RenderFile(Filename)

            'I[fBI`̎擾ƃ`FbN
            Dim smpmt As New AM_MEDIA_TYPE
            mSmp.GetConnectedMediaType(smpmt)   'ȂꍇO
            If Not smpmt.formatType.Equals(New Guid(FormatTypeGUID.FORMAT_WaveFormatEx)) Then
                Throw New DSException("T|[gǑ`łB")
            End If
            mFmt = DSUtility.PtrToStructure(Of DSWAVEFORMATEX)(smpmt.formatPtr)

            'obt@
            mBuff = New WaveBuffer(mFmt.Channels, mFmt.BitsPerSample, CInt(mFmt.SamplesPerSec), BUFFERINGTIME)

            'TvO
            mSmp.SetCallback(mBuff, 1)      'R[obN̐ݒ
            mSmp.SetBufferSamples(True)     'TvOJn

            'eC^[tF[X擾
            mCtl = CType(mGrp, IMediaControl)
            mPos = CType(mGrp, IMediaPosition)

            '̕\
            Dim fmtmsg As New System.Text.StringBuilder
            Select Case mFmt.Channels
                Case 1 : fmtmsg.Append("Mono")
                Case 2 : fmtmsg.Append("Stereo")
                Case Else : fmtmsg.AppendFormat("{0}ch", mFmt.Channels)
            End Select
            fmtmsg.AppendFormat(", {0}[bits], {1}[Hz]", mFmt.BitsPerSample, mFmt.SamplesPerSec)
            Lbl_Info.Text = fmtmsg.ToString

        Catch ex As Exception
            'Ot\zs

            'Otj
            DestroyGraph()

            'OX[
            Throw New DSException(ex, "OtɎs܂B")

        End Try

    End Sub

    'Ot̔j
    Private Sub DestroyGraph()

        If mGrp Is Nothing Then Exit Sub

        'Ot̒~
        If Not mCtl Is Nothing Then mCtl.Stop()

        '
        mCtl = Nothing
        DSUtility.ReleaseInstance(mGrp)

    End Sub

    '----------------------------------------------------------

    '`^C}[
    Private Sub Timer_Draw_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_Draw.Tick

        'ԃ`FbN
        If mSmp Is Nothing Then Exit Sub
        If mPos Is Nothing Then Exit Sub

        '݈ʒu擾
        Dim pos As Double
        mPos.get_CurrentPosition(pos)

        'g`f[^擾
        mBuff.ReadWave(CInt(pos * mFmt.SamplesPerSec), mWave, SAMPLECOUNT)

        '`
        DrawWave(mWave, SAMPLECOUNT)

    End Sub

    '----------------------------------------------------------

    'g`̕`
    Private Sub DrawWave(ByRef Wave() As WaveData, ByVal Count As Integer)

        '`
        Dim g As Graphics = Graphics.FromImage(Pic_View.Image)
        Select Case True
            Case Rdo_View1.Checked
                DrawWave_Mono(g, Pic_View.ClientRectangle, Wave, Count)

            Case Rdo_View2.Checked
                DrawWave_Freq(g, Pic_View.ClientRectangle, Wave, Count)

            Case Rdo_View3.Checked
                DrawWave_GraEco(g, Pic_View.ClientRectangle, Wave, Count)

        End Select

        'XV
        Pic_View.Refresh()

    End Sub

    '`img`j
    Private Sub DrawWave_Mono(ByVal g As Graphics, ByVal DrawRect As Rectangle, ByRef Wave() As WaveData, ByVal Count As Integer)

        'NA
        g.Clear(Pic_View.BackColor)
        'g.FillRectangle(New SolidBrush(Color.FromArgb(64, 255, 255, 255)), DrawRect) '߂

        '`
        Dim h As Integer = DrawRect.Height \ 2
        Dim y As Integer
        Dim yy As Integer = h
        For x As Integer = 0 To Count - 1
            y = CInt(h * Wave(x).MonoLevel / 32767 + h)
            g.DrawLine(Pens.Black, x - 1, yy, x, y)
            yy = y
        Next

    End Sub

    '`igj
    Private Sub DrawWave_Freq(ByVal g As Graphics, ByVal DrawRect As Rectangle, ByRef Wave() As WaveData, ByVal Count As Integer)
        Static DCTModule As DCT = Nothing       'DCTW[
        Static Lvl() As Integer                 'DCT(g`)
        Static Frq() As Integer                 'DCTo(g)

        '񎞂̂
        If DCTModule Is Nothing Then
            DCTModule = New DCT
            DCTModule.Initialize(SAMPLECOUNT)
            ReDim Lvl(SAMPLECOUNT - 1)
            ReDim Frq(SAMPLECOUNT - 1)
        End If


        'g`f[^o
        For x As Integer = 0 To SAMPLECOUNT - 1
            Lvl(x) = mWave(x).MonoLevel
        Next

        'g擾
        DCTModule.Translation(Lvl, Frq)

        'NA
        g.Clear(Pic_View.BackColor)
        'g.FillRectangle(New SolidBrush(Color.FromArgb(64, 255, 255, 255)), DrawRect) '߂

        '`
        Dim h As Integer = DrawRect.Height
        Dim y As Integer
        For x As Integer = 0 To Count - 1
            y = h - CInt(h * Math.Abs(Frq(x)) / 32767)
            g.DrawLine(Pens.Red, x, h, x, y)
        Next

    End Sub

    '`iOGRj
    Private Sub DrawWave_GraEco(ByVal g As Graphics, ByVal DrawRect As Rectangle, ByRef Wave() As WaveData, ByVal Count As Integer)
        Static DCTModule As DCT = Nothing       'DCTW[
        Static Lvl() As Integer                 'DCT(g`)
        Static Frq() As Integer                 'DCTo(g)
        Static rcnt As Integer                  '敪
        Static vol() As Integer                 'e敪̃x

        '񎞂̂
        If DCTModule Is Nothing Then
            DCTModule = New DCT
            DCTModule.Initialize(SAMPLECOUNT)
            ReDim Lvl(SAMPLECOUNT - 1)
            ReDim Frq(SAMPLECOUNT - 1)
            rcnt = CInt(Math.Log(SAMPLECOUNT, 2))
            ReDim vol(rcnt - 1)
        End If

        'g`f[^o
        For x As Integer = 0 To SAMPLECOUNT - 1
            Lvl(x) = mWave(x).MonoLevel
        Next

        'g擾
        DCTModule.Translation(Lvl, Frq)

        '敪ɏWv
        For x As Integer = 0 To rcnt - 1
            vol(x) = 0
        Next
        Dim y As Integer = 0
        Dim z As Integer = 0, zz As Integer = 1
        For x As Integer = 0 To SAMPLECOUNT - 2
            vol(y) += Math.Abs(Frq(x))
            z += 1
            If z >= zz Then
                zz *= 2
                y += 1
                z = 0
            End If
        Next

        'NA
        'g.Clear(Pic_View.BackColor)
        g.FillRectangle(New SolidBrush(Color.FromArgb(64, 255, 255, 255)), DrawRect)

        '`
        Dim h As Integer = DrawRect.Height
        Dim w As Integer = SAMPLECOUNT \ rcnt
        Dim rct As Rectangle
        rct.Width = w * 8 \ 10
        For x As Integer = 0 To rcnt - 1
            rct.X = x * w
            rct.Height = CInt(h * vol(x) / (32767 * 2 ^ x))
            rct.Y = h - rct.Height
            g.FillRectangle(Brushes.Blue, rct)
        Next

    End Sub


End Class


