Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices
Imports System.drawing
Imports System.Windows.Forms


'//////////////////////////////////////////////////////////////
''' <summary>
''' DirectShowp̃[eBeBW[({)łB
''' </summary>
''' <remarks></remarks>
Public Module DSUtility

#Region "ėp֐"

    ''' <summary>
    ''' CLSIDw肵COMIuWFNg̃CX^X𐶐܂B
    ''' </summary>
    ''' <param name="CLSIDString">CLSID</param>
    ''' <returns>ꂽCX^X</returns>
    ''' <remarks></remarks>
    Public Function CoCreateInstance(ByVal CLSIDString As String) As Object

        Dim comobj As Object = Nothing
        Try
            'NXID
            Dim cid As Guid
            cid = New Guid(CLSIDString)

            '^Cv擾
            Dim comtype As Type
            comtype = Type.GetTypeFromCLSID(cid)

            'CX^X
            comobj = Activator.CreateInstance(comtype)

        Catch ex As Exception
            Throw New DSException(ex, "CX^X𐶐ł܂BCLSID=" + CLSIDString)

        End Try

        Return comobj
    End Function

    ''' <summary>
    ''' CX^XJ܂B
    ''' </summary>
    ''' <typeparam name="ObjType">COMIuWFNg̃^Cv</typeparam>
    ''' <param name="Obj">COMIuWFNg</param>
    ''' <remarks></remarks>
    Public Sub ReleaseInstance(Of ObjType)(ByRef Obj As ObjType)

        If Obj IsNot Nothing Then
            Marshal.ReleaseComObject(Obj)
            Obj = Nothing
        End If

    End Sub

    ''' <summary>
    ''' |C^e^(\)̃f[^擾܂B
    ''' A}l[Ẅ̃f[^}l[ẄɃRs[܂B
    ''' </summary>
    ''' <typeparam name="DataType">f[^^</typeparam>
    ''' <param name="Ptr">|C^</param>
    ''' <returns>擾f[^</returns>
    ''' <remarks></remarks>
    Public Function PtrToStructure(Of DataType)(ByVal Ptr As IntPtr) As DataType
        Return CType(Marshal.PtrToStructure(Ptr, GetType(DataType)), DataType)
    End Function

    ''' <summary>
    ''' GUID񓯎m̔rs܂B
    ''' </summary>
    ''' <param name="GUID1">GUIDP</param>
    ''' <param name="GUID2">GUIDQ</param>
    ''' <returns>vꍇTrueAvȂꍇFalse</returns>
    ''' <remarks>
    ''' 16ȋ啶͋ʂ܂B
    ''' [̊(u{vu}vj̗L͋ʂ܂B
    ''' </remarks>
    Public Function CompGUIDString(ByVal GUID1 As String, ByVal GUID2 As String) As Boolean
        Return NormalizeGUIDString(GUID1) = NormalizeGUIDString(GUID2)
    End Function

    ''' <summary>
    ''' GUID {xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxx} `ɐK܂B
    ''' </summary>
    ''' <param name="GuidStr">GUID</param>
    ''' <returns>`ꂽGUID</returns>
    ''' <remarks>16i͑啶gplɕύX܂B</remarks>
    Public Function NormalizeGUIDString(ByVal GuidStr As String) As String
        If Not GuidStr.StartsWith("{") Then GuidStr = "{" + GuidStr
        If Not GuidStr.EndsWith("}") Then GuidStr = GuidStr + "}"
        Return UCase(GuidStr)
    End Function

#End Region

#Region "Ot\z֌W"

    ''' <summary>
    ''' ṼOt𐶐܂B
    ''' </summary>
    ''' <returns>ꂽOtIGraphBuilderC^[tF[X</returns>
    ''' <remarks></remarks>
    Public Function CreateNewGraph() As IGraphBuilder

        Dim grp As IGraphBuilder = Nothing
        Try
            'CX^X
            Dim obj As Object = CoCreateInstance(ClassGUID.CLSID_FilterGraph)

            'IGraphBuilderC^[tF[X擾
            grp = CType(obj, IGraphBuilder)

        Catch ex As Exception
            Throw New DSException(ex, "Ot𐶐ł܂B")
        End Try

        Return grp
    End Function


    ''' <summary>
    ''' tB^̃CX^X𐶐܂B(NXIDw)
    ''' </summary>
    ''' <param name="CLSIDString">tB^̃NXID</param>
    ''' <returns>ꂽtB^CX^XIBaseFilterC^[tF[X</returns>
    ''' <remarks></remarks>
    Public Function CreateFilter(ByVal CLSIDString As String) As IBaseFilter

        Dim FilterClassID As Guid
        Try
            'NXhc
            FilterClassID = New Guid(CLSIDString)

        Catch ex As Exception
            Throw New DSException(ex, "tB^CX^X𐶐ł܂BCLSID={0} ", CLSIDString)
        End Try

        'CX^X
        Return CreateFilter(FilterClassID)

    End Function

    ''' <summary>
    ''' tB^̃CX^X𐶐܂B(NXIDw)
    ''' </summary>
    ''' <param name="CLSID">tB^̃NXID</param>
    ''' <returns>ꂽtB^CX^XIBaseFilterC^[tF[X</returns>
    ''' <remarks></remarks>
    Public Function CreateFilter(ByVal CLSID As Guid) As IBaseFilter

        Dim flt As IBaseFilter = Nothing
        Try

            '^Cv̎擾
            Dim FilterType As Type
            FilterType = Type.GetTypeFromCLSID(CLSID)

            'tB^̃CX^X쐬
            Dim FilterObject As Object
            FilterObject = Activator.CreateInstance(FilterType)

            'IBaseFilterC^[tF[X擾
            flt = TryCast(FilterObject, IBaseFilter)

        Catch ex As Exception
            Throw New DSException(ex, "tB^CX^X𐶐ł܂BCLSID={0}", CLSID.ToString)

        End Try

        Return flt
    End Function

    ''' <summary>
    ''' tB^̃CX^X𐶐܂B(JeSNXIDAtB^AXLbvw)
    ''' </summary>
    ''' <param name="Category">JeS̃NXID</param>
    ''' <param name="FilterName">tB^</param>
    ''' <param name="SkipCount">̂̃tB^ꍇ̃XLbv</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function CreateFilter(ByVal Category As String, ByVal FilterName As String, ByVal SkipCount As Integer) As IBaseFilter

        Dim cfp As New CREATEFILTERPARAM
        Try
            'tB^񋓂AΏۃtB^CX^X
            cfp.FilterName = FilterName
            cfp.SkipCount = SkipCount
            cfp.Filter = Nothing
            EnumFiltersAlgorithm(Category, New DelegateEnumFilters(AddressOf CreateFilterFunc), cfp)

        Catch ex As Exception
            Throw New DSException(ex, "tB^CX^X𐶐ł܂B- Category={0} FilterName={1} SkipCount={2}", Category, FilterName, SkipCount)

        End Try

        Return cfp.Filter
    End Function

    ''' <summary>
    ''' tB^̃CX^X𐶐܂B(JeSNXIDAtB^AXLbvw)
    ''' </summary>
    ''' <param name="Category">JeSGUID</param>
    ''' <param name="FilterName">tB^</param>
    ''' <param name="SkipCount">̂̃tB^ꍇ̃XLbv</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function CreateFilter(ByVal Category As Guid, ByVal FilterName As String, ByVal SkipCount As Integer) As IBaseFilter

        Dim cfp As New CREATEFILTERPARAM
        Try
            'tB^񋓂AΏۃtB^CX^X
            cfp.FilterName = FilterName
            cfp.SkipCount = SkipCount
            cfp.Filter = Nothing
            EnumFiltersAlgorithm(Category, New DelegateEnumFilters(AddressOf CreateFilterFunc), cfp)

        Catch ex As Exception
            Throw New DSException(ex, "tB^CX^X𐶐ł܂B- Category={0} FilterName={1} SkipCount={2}", Category, FilterName, SkipCount)

        End Try

        Return cfp.Filter

    End Function

    ''' <summary>
    ''' tB^̃CX^X𐶐܂B(JeSNXIDACfbNXw)
    ''' </summary>
    ''' <param name="Category">JeS̃NXID</param>
    ''' <param name="Index">CfbNX</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function CreateFilter(ByVal Category As String, ByVal Index As Integer) As IBaseFilter

        Dim cfp As New CREATEFILTERPARAM
        Try
            'tB^񋓂AΏۃtB^CX^X
            cfp.FilterName = ""
            cfp.SkipCount = Index
            cfp.Filter = Nothing
            EnumFiltersAlgorithm(Category, New DelegateEnumFilters(AddressOf CreateFilterFunc), cfp)

        Catch ex As Exception
            Throw New DSException(ex, "tB^CX^X𐶐ł܂B- Category={0} Index={1}", Category, Index)

        End Try

        Return cfp.Filter

    End Function

    ''' <summary>
    ''' tB^̃CX^X𐶐܂B(JeSNXIDACfbNXw)
    ''' </summary>
    ''' <param name="Category">JeSGUID</param>
    ''' <param name="Index">CfbNX</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function CreateFilter(ByVal Category As Guid, ByVal Index As Integer) As IBaseFilter

        Dim cfp As New CREATEFILTERPARAM
        Try
            'tB^񋓂AΏۃtB^CX^X
            cfp.FilterName = ""
            cfp.SkipCount = Index
            cfp.Filter = Nothing
            EnumFiltersAlgorithm(Category, New DelegateEnumFilters(AddressOf CreateFilterFunc), cfp)

        Catch ex As Exception
            Throw New DSException(ex, "tB^CX^X𐶐ł܂B- Category={0} Index={1}", Category, Index)

        End Try

        Return cfp.Filter

    End Function

    ''' <summary>
    ''' tB^CX^X̗񋓏p֐łB
    ''' </summary>
    ''' <param name="Mon">jJ</param>
    ''' <param name="PropertyBag">vpeBobO</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks>̃\bh͓płBʏAvP[V͎gp܂B</remarks>
    Private Function CreateFilterFunc(ByRef Mon As ComTypes.IMoniker, ByVal PropertyBag As IPropertyBag, ByVal Param As Object) As Boolean

        Try

            'p^擾
            Dim cfp As CREATEFILTERPARAM = CType(Param, CREATEFILTERPARAM)

            'ΏۃtB^̔f
            Dim istarget As Boolean = False
            If cfp.FilterName <> "" Then
                'Ow肠

                'O擾
                Dim fnameobj As Object = Nothing
                PropertyBag.Read("FriendlyName", fnameobj, 0)
                Dim fname As String = CStr(fnameobj)
                fnameobj = Nothing

                If fname = cfp.FilterName Then
                    If cfp.SkipCount > 0 Then
                        'XLbv
                        cfp.SkipCount -= 1
                    Else
                        'ΏۃtB^
                        istarget = True
                    End If
                End If
            Else
                'OwȂ

                If cfp.SkipCount > 0 Then
                    'XLbv
                    cfp.SkipCount -= 1
                Else
                    'ΏۃtB^
                    istarget = True
                End If
            End If

            If istarget Then
                'ΏۃtB^

                'tB^CX^X擾
                Dim fltobj As Object = Nothing
                Mon.BindToObject(Nothing, Nothing, New Guid(InterfaceGUID.IID_IBaseFilter), fltobj)
                If fltobj Is Nothing Then Throw New DSException("jJʂIuWFNgɃoCho܂B- {0}", cfp.FilterName)
                Dim flt As IBaseFilter = CType(fltobj, IBaseFilter)
                cfp.Filter = flt

                '񋓏I
                Return True
            End If

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "tB^̗񋓒ɖ肪܂B")
        End Try

        '񋓌p
        Return False
    End Function

    ''' <summary>
    ''' tB^CX^X̗񋓏p\̂łB
    ''' </summary>
    ''' <remarks>̍\͓̂płBʏAvP[V͎gp܂B</remarks>
    Private Class CREATEFILTERPARAM
        ''' <summary>tB^̂łB</summary>
        Public FilterName As String
        ''' <summary>XLbvłB</summary>
        Public SkipCount As Integer
        ''' <summary>tB^łB</summary>
        Public Filter As IBaseFilter
    End Class


    ''' <summary>
    ''' OtɃtB^ǉ܂B(NXIDw)
    ''' </summary>
    ''' <param name="Grp">tB^ǉOt</param>
    ''' <param name="CLSIDString">tB^̃NXID</param>
    ''' <param name="FilterCaption">tB^̕\</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function AddFilter(ByVal Grp As IGraphBuilder, ByVal CLSIDString As String, Optional ByVal FilterCaption As String = "") As IBaseFilter

        Dim flt As IBaseFilter = Nothing
        Try

            'tB^CX^X
            flt = CreateFilter(CLSIDString)

            'Otɒǉ
            Grp.AddFilter(flt, FilterCaption)

        Catch ex As Exception
            Throw New DSException(ex, "OtɃtB^ǉł܂B- {0}", CLSIDString)
        End Try

        Return flt
    End Function

    ''' <summary>
    ''' OtɃtB^ǉ܂B(NXIDw)
    ''' </summary>
    ''' <param name="Grp">tB^ǉOt</param>
    ''' <param name="CLSID">tB^̃NXID</param>
    ''' <param name="FilterCaption">tB^̕\</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function AddFilter(ByVal Grp As IGraphBuilder, ByVal CLSID As Guid, Optional ByVal FilterCaption As String = "") As IBaseFilter

        Dim flt As IBaseFilter = Nothing
        Try

            'tB^CX^X
            flt = CreateFilter(CLSID)

            'Otɒǉ
            Grp.AddFilter(flt, FilterCaption)

        Catch ex As Exception
            Throw New DSException(ex, "OtɃtB^ǉł܂B- {0}", CLSID)
        End Try

        Return flt
    End Function

    ''' <summary>
    ''' OtɃtB^ǉ܂B(JeSNXIDAtB^AXLbvw)
    ''' </summary>
    ''' <param name="Category">JeS̃NXID</param>
    ''' <param name="FilterName">tB^</param>
    ''' <param name="SkipCount">̂̃tB^ꍇ̃XLbv</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function AddFilter(ByVal Grp As IGraphBuilder, ByVal Category As String, ByVal FilterName As String, ByVal SkipCount As Integer, Optional ByVal FilterCaption As String = "") As IBaseFilter

        Dim flt As IBaseFilter = Nothing
        Try

            'tB^CX^X
            flt = CreateFilter(Category, FilterName, SkipCount)

            'Otɒǉ
            Grp.AddFilter(flt, FilterCaption)

        Catch ex As Exception
            Throw New DSException(ex, "OtɃtB^ǉł܂B- {0}/{1}/{2}", Category, FilterName, SkipCount)
        End Try

        Return flt

    End Function

    ''' <summary>
    ''' OtɃtB^ǉ܂B(JeSNXIDAtB^AXLbvw)
    ''' </summary>
    ''' <param name="Category">JeSGUID</param>
    ''' <param name="FilterName">tB^</param>
    ''' <param name="SkipCount">̂̃tB^ꍇ̃XLbv</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function AddFilter(ByVal Grp As IGraphBuilder, ByVal Category As Guid, ByVal FilterName As String, ByVal SkipCount As Integer, Optional ByVal FilterCaption As String = "") As IBaseFilter

        Dim flt As IBaseFilter = Nothing
        Try

            'tB^CX^X
            flt = CreateFilter(Category, FilterName, SkipCount)

            'Otɒǉ
            Grp.AddFilter(flt, FilterCaption)

        Catch ex As Exception
            Throw New DSException(ex, "OtɃtB^ǉł܂B- {0}/{1}/{2}", Category, FilterName, SkipCount)
        End Try

        Return flt

    End Function

    ''' <summary>
    ''' OtɃtB^ǉ܂B(JeSNXIDACfbNXw)
    ''' </summary>
    ''' <param name="Category">JeS̃NXID</param>
    ''' <param name="Index">CfbNX</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function AddFilter(ByVal Grp As IGraphBuilder, ByVal Category As String, ByVal Index As Integer, Optional ByVal FilterCaption As String = "") As IBaseFilter

        Dim flt As IBaseFilter = Nothing
        Try

            'tB^CX^X
            flt = CreateFilter(Category, Index)

            'Otɒǉ
            Grp.AddFilter(flt, FilterCaption)

        Catch ex As Exception
            Throw New DSException(ex, "OtɃtB^ǉł܂B- {0}/{1}", Category, Index)
        End Try

        Return flt

    End Function

    ''' <summary>
    ''' OtɃtB^ǉ܂B(JeSNXIDACfbNXw)
    ''' </summary>
    ''' <param name="Category">JeS̃NXID</param>
    ''' <param name="Index">CfbNX</param>
    ''' <returns>ꍇꂽCX^XAsꍇNothingB</returns>
    ''' <remarks></remarks>
    Public Function AddFilter(ByVal Grp As IGraphBuilder, ByVal Category As Guid, ByVal Index As Integer, Optional ByVal FilterCaption As String = "") As IBaseFilter

        Dim flt As IBaseFilter = Nothing
        Try

            'tB^CX^X
            flt = CreateFilter(Category, Index)

            'Otɒǉ
            Grp.AddFilter(flt, FilterCaption)

        Catch ex As Exception
            Throw New DSException(ex, "OtɃtB^ǉł܂B- {0}/{1}", Category, Index)
        End Try

        Return flt

    End Function

#End Region

#Region "擾"

#Region "o^ς݃tB^"

    ''' <summary>
    ''' tB^񋓂܂B
    ''' </summary>
    ''' <param name="Category">񋓂JeSGUID</param>
    ''' <returns>񋓂ꂽtB^̏(FILTERINFORMATION)̃Xg</returns>
    ''' <remarks></remarks>
    Public Function EnumFilters(ByVal Category As String) As List(Of FILTERINFORMATION)
        Return EnumFilters(New Guid(Category))
    End Function

    ''' <summary>
    ''' tB^񋓂܂B
    ''' </summary>
    ''' <param name="Category">񋓂JeSGUID</param>
    ''' <returns>񋓂ꂽtB^Ɋւ(FILTERINFORMATION)̃Xg</returns>
    ''' <remarks></remarks>
    Public Function EnumFilters(ByVal Category As Guid) As List(Of FILTERINFORMATION)

        Dim ret As New List(Of FILTERINFORMATION)
        Try

            '
            EnumFiltersAlgorithm(Category, New DelegateEnumFilters(AddressOf EnumFiltersFunc), ret)

            'tB^̏ԕt
            For x As Integer = 1 To ret.Count - 1
                Dim idx As Integer = 0
                For y As Integer = 0 To x - 1
                    If ret(x).Name = ret(y).Name Then
                        idx += 1
                    End If
                Next
                ret(x).Index = idx
            Next

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "tB^̗񋓂Ɏs܂B")
        End Try

        Return ret
    End Function

    ''' <summary>
    ''' tB^񋓎̗񋓏p֐łB
    ''' </summary>
    ''' <param name="Mon">jJ</param>
    ''' <param name="PropertyBag">vpeBobO</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks>̃\bh͓płBʏAvP[V͎gp܂B</remarks>
    Private Function EnumFiltersFunc(ByRef Mon As ComTypes.IMoniker, ByVal PropertyBag As IPropertyBag, ByVal Param As Object) As Boolean

        Try
            Dim fi As New FILTERINFORMATION

            'O擾
            Dim fnameobj As Object = Nothing
            Try
                PropertyBag.Read("FriendlyName", fnameobj, 0)
                fi.Name = CStr(fnameobj)
                fnameobj = Nothing
            Catch ex As Exception
                fi.Name = ""
            End Try

            'CLSID擾
            Dim cidobj As Object = Nothing
            Try
                PropertyBag.Read("CLSID", cidobj, 0)
                fi.CLSID = CStr(cidobj)
                cidobj = Nothing
            Catch ex As Exception
                fi.CLSID = ""
            End Try

            'RNVɒǉ
            Dim lst As List(Of FILTERINFORMATION) = CType(Param, List(Of FILTERINFORMATION))
            lst.Add(fi)

        Catch ex As Exception
            Throw New DSException(ex, "tB^̎擾Ɏs܂B")
        End Try

        Return False
    End Function

    ''' <summary>
    ''' tB^񋓗pf[^NXłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Class FILTERINFORMATION

        ''' <summary>tB^̂łB</summary>
        Public Name As String
        ''' <summary>tB^GUIDłB</summary>
        Public CLSID As String
        ''' <summary>tB^Ƃ̏(0Jn)łB</summary>
        Public Index As Integer

        ''' <summary>
        ''' tB^̂Ԃ܂B
        ''' </summary>
        ''' <returns>tB^</returns>
        ''' <remarks></remarks>
        Public Overrides Function ToString() As String
            Return Name
        End Function

    End Class

#End Region

#Region "tB^E擾"

    ''' <summary>
    ''' tB^̖̂擾܂B
    ''' </summary>
    ''' <param name="Filter">ΏۃtB^</param>
    ''' <returns>tB^</returns>
    ''' <remarks></remarks>
    Public Function GetFilterName(ByVal Filter As IBaseFilter) As String

        Dim inf As New FILTER_INFO
        Try

            'tB^擾
            Filter.QueryFilterInfo(inf)
            If inf.pUnk IsNot Nothing Then Marshal.ReleaseComObject(inf.pUnk)

        Catch ex As Exception
            Throw New DSException(ex, "tB^̂擾ł܂B")
        End Try

        Return inf.achName
    End Function

    ''' <summary>
    ''' Ot̃tB^w肳ꂽC^[tF[XtB^܂B
    ''' </summary>
    ''' <typeparam name="TargetInterface">ΏۃC^[tF[X</typeparam>
    ''' <param name="Grp">Ot</param>
    ''' <returns>ꍇC^[tF[XAȂꍇNothing</returns>
    ''' <remarks>̃tB^ΏۃC^[tF[XĂĂA߂ɌtB^݂̂Ԃ܂B</remarks>
    Public Function FindInterface(Of TargetInterface)(ByVal Grp As IGraphBuilder) As TargetInterface

        Dim ret As TargetInterface = Nothing
        Dim eflt As IEnumFilters = Nothing
        Dim flt As IBaseFilter = Nothing
        Try
            'tB^̗񋓊Jn
            Grp.EnumFilters(eflt)

            '
            Dim fc As Integer = 0
            Do While eflt.Next(1, flt, fc) = 0
                If fc = 0 Then Exit Do

                If TypeOf flt Is TargetInterface Then
                    '

                    'C^[tF[X擾
                    ret = CType(flt, TargetInterface)
                    Exit Do
                End If

                ReleaseInstance(flt)
            Loop

        Catch ex As Exception

        Finally
            '񋓏I
            ReleaseInstance(eflt)
        End Try

        Return ret
    End Function

#End Region

#Region "s擾"

    ''' <summary>
    ''' s񋓂܂B
    ''' </summary>
    ''' <param name="Filter">tB^</param>
    ''' <returns>񋓂ꂽs̏(PININFORMATION)̃Xg</returns>
    ''' <remarks></remarks>
    Public Function EnumPins(ByVal Filter As IBaseFilter) As List(Of PININFORMATION)

        Dim ret As New List(Of PININFORMATION)
        Try

            '
            EnumPinsAlgorithm(Filter, New DelegateEnumPins(AddressOf EnumPinsFunc), ret)

        Catch ex As Exception
            Throw New DSException(ex, "s̗񋓂Ɏs܂B")
        End Try

        Return ret
    End Function

    ''' <summary>
    ''' s񋓎̗񋓏֐łB
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks>̃\bh͓płBʏAvP[V͎gp܂B</remarks>
    Private Function EnumPinsFunc(ByRef Pin As IPin, ByVal Param As Object) As Boolean

        Try
            Dim pi As New PININFORMATION

            's擾
            Dim pf As New PIN_INFO
            Pin.QueryPinInfo(pf)
            pi.Name = pf.Name
            pi.Direction = pf.PinDir
            If Not pf.Filter Is Nothing Then Marshal.ReleaseComObject(pf.Filter)

            'RNVɒǉ
            CType(Param, List(Of PININFORMATION)).Add(pi)

        Catch ex As Exception
            Throw New DSException(ex, "s̎擾Ɏs܂B")
        End Try

        '񋓌p
        Return False
    End Function

    ''' <summary>
    ''' s񋓗pf[^NXłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Class PININFORMATION
        ''' <summary>ŝłB</summary>
        Public Name As String
        ''' <summary>šłB</summary>
        Public Direction As PIN_DIRECTION

        ''' <summary>
        ''' ŝ擾܂B
        ''' </summary>
        ''' <returns>s</returns>
        ''' <remarks></remarks>
        Public Overrides Function ToString() As String
            Return Name
        End Function

    End Class


    ''' <summary>
    ''' s܂B
    ''' </summary>
    ''' <param name="Filter">tB^</param>
    ''' <param name="PinName">s</param>
    ''' <returns>ꍇsIPinC^[tF[XԂBȂꍇNothingԂB</returns>
    ''' <remarks></remarks>
    Public Function FindPin(ByVal Filter As IBaseFilter, ByVal PinName As String) As IPin

        Dim fpp As New FINDPINPARAM
        Try

            '
            fpp.Name = PinName
            fpp.Pin = Nothing
            EnumPinsAlgorithm(Filter, New DelegateEnumPins(AddressOf FindPinFunc), fpp)

        Catch ex As Exception
            Throw New DSException(ex, "šɎs܂B- {0}", PinName)
        End Try

        Return fpp.Pin
    End Function

    ''' <summary>
    ''' s܂B
    ''' </summary>
    ''' <param name="Filter">tB^</param>
    ''' <param name="Index">ԍ</param>
    ''' <param name="PinDir">(PinDirection.Unknownw肵ꍇAɊ֌WȂ񋓂܂)</param>
    ''' <returns>ꍇsIPinC^[tF[XԂBȂꍇNothingԂB</returns>
    ''' <remarks></remarks>
    Public Function FindPin(ByVal Filter As IBaseFilter, ByVal Index As Integer, ByVal PinDir As PIN_DIRECTION) As IPin

        Dim fpp As New FINDPINPARAM
        Try

            '
            fpp.Name = ""
            fpp.Index = Index
            fpp.Pin = Nothing
            fpp.Direction = PinDir
            EnumPinsAlgorithm(Filter, New DelegateEnumPins(AddressOf FindPinFunc), fpp)

        Catch ex As Exception
            Throw New DSException(ex, "šɎs܂B- {0}/{1}", Index, PinDir)
        End Try

        Return fpp.Pin
    End Function

    ''' <summary>
    ''' s̗񋓏p֐łB
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks>̃\bh͓płBʏAvP[V͎gp܂B</remarks>
    Private Function FindPinFunc(ByRef Pin As IPin, ByVal Param As Object) As Boolean

        Try

            'p^擾
            Dim fpp As FINDPINPARAM = CType(Param, FINDPINPARAM)

            's擾
            Dim pf As New PIN_INFO
            Pin.QueryPinInfo(pf)
            If Not pf.Filter Is Nothing Then Marshal.ReleaseComObject(pf.Filter)

            '
            If fpp.Name <> "" Then
                'Ow
                If pf.Name = fpp.Name Then
                    '
                    fpp.Pin = Pin

                    'PinIuWFNgReleaseȂ悤ɂ
                    Pin = Nothing

                    '񋓏I
                    Return True
                End If
            Else
                'Ԏw

                If pf.PinDir = fpp.Direction Then
                    If fpp.Index = 0 Then
                        '
                        fpp.Pin = Pin

                        'PinIuWFNgReleaseȂ悤ɂ
                        Pin = Nothing

                        '񋓏I
                        Return True
                    End If

                    fpp.Index -= 1
                End If

            End If

        Catch ex As Exception
            Throw New DSException(ex, "šɎs܂B")
        End Try

        '񋓌p
        Return False
    End Function

    ''' <summary>
    ''' spf[^NXłB
    ''' </summary>
    ''' <remarks>̃NX͓płBʏAvP[V͎gp܂B</remarks>
    Private Class FINDPINPARAM
        ''' <summary>̖̂łB</summary>
        Public Name As String
        ''' <summary>̃słB</summary>
        Public Direction As PIN_DIRECTION
        ''' <summary>ꂽsłB</summary>
        Public Pin As IPin
        ''' <summary>ԂłB</summary>
        Public Index As Integer
    End Class

    ''' <summary>
    ''' ŝ̖擾܂B
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <returns>s</returns>
    ''' <remarks></remarks>
    Public Function GetPinName(ByVal Pin As IPin) As String

        Dim PINFO As New PIN_INFO
        Try

            's擾
            Pin.QueryPinInfo(PINFO)

            'Еt
            If Not PINFO.Filter Is Nothing Then Marshal.ReleaseComObject(PINFO.Filter)

        Catch ex As Exception
            Throw New DSException(ex, "ŝ̎擾Ɏs܂B")
        End Try

        Return PINFO.Name
    End Function

#End Region

#Region ""

    ''' <summary>
    ''' ̉摜TCY(cTCY)擾܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetVideoSize(ByVal Grp As IGraphBuilder) As Size

        Dim ret As Size
        Try
            'IBasicVideo2C^[tF[X擾
            Dim bv As IBasicVideo2 = TryCast(Grp, IBasicVideo2)
            If bv Is Nothing Then Throw New DSException("rfIXg[܂B")

            '摜TCY擾
            bv.GetVideoSize(ret.Width, ret.Height)

        Catch ex As Exception
            Throw New DSException(ex, "rfITCY擾ł܂B")

        End Try

        '
        Return ret
    End Function

#End Region

#Region "Ot"

    ''' <summary>
    ''' ݂̃OtԂ擾܂B(IMediaControlw)
    ''' </summary>
    ''' <param name="Ctl">IMediaControlC^[tF[X</param>
    ''' <returns>݂̃Ot</returns>
    ''' <remarks>
    ''' ԕύX͖߂lBusyZ܂B
    ''' Ԏ擾ɎsꍇUnknownԂ܂B
    ''' </remarks>
    Public Function GetGraphState(ByVal Ctl As IMediaControl) As FILTER_STATE

        Dim ret As FILTER_STATE = FILTER_STATE.Unknown
        Try

            'Ԏ擾
            Dim ss As Integer
            Dim rc As Integer
            rc = Ctl.GetState(10, ss)

            'Ԍ
            ret = CType(ss, FILTER_STATE)
            If rc = DirectShowHRESULT.VFW_S_STATE_INTERMEDIATE Then
                ret = ret Or FILTER_STATE.Busy
            End If

        Catch ex As Exception
            Throw New DSException(ex, "OtԂ̎擾Ɏs܂B")

        End Try

        Return ret
    End Function

    ''' <summary>
    ''' ݂̃OtԂ擾܂B(IGraphBuilderw)
    ''' </summary>
    ''' <returns>݂̃Ot</returns>
    ''' <remarks>
    ''' ԕύX͖߂lBusyZ܂B
    ''' Ԏ擾ɎsꍇUnknownԂ܂B
    ''' </remarks>
    Public Function GetGraphState(ByVal Grp As IGraphBuilder) As FILTER_STATE
        Return GetGraphState(CType(Grp, IMediaControl))
    End Function

#End Region

#End Region

#Region "tH[}bg擾Eݒ"

    ''' <summary>
    ''' T|[gĂtH[}bg񋓂܂B
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <returns>񋓂ꂽtH[}bg(FORMATINFORMATION)̃Xg</returns>
    ''' <remarks></remarks>
    Public Function EnumFormat(ByVal Pin As IPin) As List(Of FORMATINFORMATION)

        Dim ret As New List(Of FORMATINFORMATION)

        Try
            '
            EnumFormatAlgorithm(Pin, New DelegateEnumFormat(AddressOf EnumFormatFunc), ret)

        Catch ex As Exception
            Throw New DSException(ex, "tH[}bg̗񋓂Ɏs܂B")

        End Try

        Return ret
    End Function

    ''' <summary>
    ''' tH[}bg`񋓎̗񋓏֐łB
    ''' </summary>
    ''' <param name="MediaType">fBA^Cv</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks>̃\bh͓płBʏAvP[V͎gp܂B</remarks>
    Private Function EnumFormatFunc(ByRef MediaType As AM_MEDIA_TYPE, ByVal Param As Object) As Boolean

        Try

            '{̎擾
            Dim fmt As New FORMATINFORMATION
            fmt.MajorType = MediaType.majorType
            fmt.SubType = MediaType.subType
            fmt.FormatType = MediaType.formatType

            'f`̏ꍇATCY擾
            If CompGUIDString(MediaType.formatType.ToString, FormatTypeGUID.FORMAT_VideoInfo) Then
                'f`ł
                Dim vinfo As New DSVIDEOINFOHEADER
                vinfo = PtrToStructure(Of DSVIDEOINFOHEADER)(MediaType.formatPtr)
                fmt.VideoSize.Width = vinfo.BmiHeader.Width
                fmt.VideoSize.Height = vinfo.BmiHeader.Height
            End If

            'RNVɒǉ
            CType(Param, List(Of FORMATINFORMATION)).Add(fmt)

        Catch ex As Exception
            Throw New DSException(ex, "tH[}bg̎擾Ɏs܂B")
        End Try

        Return False
    End Function

    ''' <summary>
    ''' tH[}bg`񋓎̃f[^NXłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Class FORMATINFORMATION
        ''' <summary>W[^CvłB</summary>
        ''' <remarks>f^𔻒fł܂B</remarks>
        Public MajorType As Guid
        ''' <summary>Tu^CvłB</summary>
        ''' <remarks>f^𔻒fł܂B</remarks>
        Public SubType As Guid
        ''' <summary>tH[}bg^CvłB</summary>
        Public FormatType As Guid
        ''' <summary>TCYłB</summary>
        ''' <remarks>܂܂ȂꍇAłB</remarks>
        Public VideoSize As Size

        ''' <summary>
        ''' 񉻂擾܂B
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Overrides Function ToString() As String
            Return GetMediaTypeName(MajorType.ToString) + ":" _
                    + GetMediaTypeName(SubType.ToString) + ":" _
                    + GetMediaTypeName(FormatType.ToString) + ":" _
                    + String.Format("{0} x {1}", VideoSize.Width, VideoSize.Height)
        End Function

    End Class

    ''' <summary>
    ''' T|[gĂtH[}bg`̌擾܂B
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <returns>T|[gĂtH[}bǧ</returns>
    ''' <remarks></remarks>
    Public Function GetFormatCount(ByVal Pin As IPin) As Integer

        Dim ret As Integer = 0
        Try

            'IAMStreamConfigC^[tF[X̎擾
            If Pin Is Nothing Then Return -1
            Dim asc As IAMStreamConfig = TryCast(Pin, IAMStreamConfig)
            If asc Is Nothing Then Throw New DSException("̃foCX̓tH[}bg񋓂ł܂B")

            'tH[}bg擾
            Dim ssz As Integer = 0
            asc.GetNumberOfCapabilities(ret, ssz)

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "tH[}bg̎擾Ɏs܂B")

        End Try

        Return ret
    End Function

    ''' <summary>
    ''' tH[}bg`擾܂B
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <param name="Index">tH[}bg`̔ԍ</param>
    ''' <returns>tH[}bg</returns>
    ''' <remarks>擾ɐꍇA擾f[^DeleteMediaTypeŉKv܂B</remarks>
    Public Function GetFormat(ByVal Pin As IPin, ByVal Index As Integer) As AM_MEDIA_TYPE

        Dim mt As AM_MEDIA_TYPE = Nothing
        Dim dataptr As IntPtr = IntPtr.Zero
        Try
            If Pin Is Nothing Then Throw New DSException("NothingłB")

            'IAMStreamConfigC^[tF[X̎擾
            Dim asc As IAMStreamConfig = TryCast(Pin, IAMStreamConfig)
            If asc Is Nothing Then Throw New DSException("̃foCX̓tH[}bg񋓂ł܂B")

            'tH[}bg擾
            Dim fcnt As Integer = 0
            Dim ssz As Integer = 0
            asc.GetNumberOfCapabilities(fcnt, ssz)

            'f[^p̈m
            dataptr = Marshal.AllocHGlobal(ssz)

            'fBA^Cv擾
            asc.GetStreamCaps(Index, mt, dataptr)

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "tH[}bg̎擾Ɏs܂B")

        Finally
            If dataptr = IntPtr.Zero Then Marshal.FreeHGlobal(dataptr)

        End Try

        Return mt
    End Function

    ''' <summary>
    ''' ݂̃tH[}bg`擾܂B
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <returns>݂̃tH[}bg</returns>
    ''' <remarks>擾ɐꍇA擾f[^DeleteMediaTypeŉKv܂B</remarks>
    Public Function GetFormat(ByVal Pin As IPin) As AM_MEDIA_TYPE

        Dim mt As AM_MEDIA_TYPE = Nothing
        Dim dataptr As IntPtr = IntPtr.Zero
        Try
            If Pin Is Nothing Then Throw New DSException("NothingłB")

            'IAMStreamConfigC^[tF[X̎擾
            Dim asc As IAMStreamConfig = TryCast(Pin, IAMStreamConfig)
            If asc Is Nothing Then Throw New DSException("Iꂽs̓tH[}bg񋓂ł܂B")

            'fBA^Cv擾
            asc.GetFormat(mt)

        Catch ex As Exception
            Throw New DSException(ex, "݂̃tH[}bg擾Ɏs܂B")

        End Try

        Return mt
    End Function

    ''' <summary>
    ''' tH[}bg`ݒ肵܂B
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <param name="Format">ݒ肷tH[}bg`</param>
    ''' <remarks></remarks>
    Public Sub SetFormat(ByVal Pin As IPin, ByVal Format As AM_MEDIA_TYPE)

        Try

            'IAMStreamConfigC^[tF[X̎擾
            If Pin Is Nothing Then Exit Sub
            Dim asc As IAMStreamConfig = TryCast(Pin, IAMStreamConfig)
            If asc Is Nothing Then Throw New DSException("̃foCX̓tH[}bgݒł܂B")

            'fBA^Cvݒ
            asc.SetFormat(Format)

        Catch ex As Exception
            Throw New DSException(ex, "tH[}bg̐ݒɎs܂B")
        End Try

    End Sub

#End Region

#Region "fBA^Cv֌W"

    ''' <summary>
    ''' fBA^Cv̗̈܂B
    ''' </summary>
    ''' <param name="Ptr">郁fBA^Cṽ|C^</param>
    ''' <remarks></remarks>
    Public Sub DeleteMediaType(ByVal Ptr As IntPtr)

        Try
            '̃|C^o擾邽߁A}l[ẄɃRs[
            Dim mt As AM_MEDIA_TYPE = Nothing
            mt = PtrToStructure(Of AM_MEDIA_TYPE)(Ptr)

            '̃|C^o
            DeleteMediaType(mt)

            '
            Marshal.FreeCoTaskMem(Ptr)

        Catch ex As DSException
            Throw

        Catch ex As Exception
            Throw New DSException(ex, "fBA^Cv̈̉Ɏs܂B")
        End Try

    End Sub

    ''' <summary>
    ''' fBA^Cv̗̈܂B
    ''' </summary>
    ''' <param name="Data">郁fBA^Cv</param>
    ''' <remarks></remarks>
    Public Sub DeleteMediaType(ByRef Data As AM_MEDIA_TYPE)

        Try
            If Data.formatSize <> 0 Then
                Marshal.FreeCoTaskMem(Data.formatPtr)
            End If
            If Data.unkPtr <> IntPtr.Zero Then
                Marshal.FreeCoTaskMem(Data.unkPtr)
            End If

            Data = Nothing

        Catch ex As Exception
            Throw New DSException(ex, "fBA^Cv̈̉Ɏs܂B")

        End Try

    End Sub

    ''' <summary>
    ''' fBA^CvGUID񂩂킩Ղ̂擾܂B
    ''' </summary>
    ''' <param name="GUIDStr">GUID</param>
    ''' <returns>W[^Cv^Tu^Cv̖</returns>
    ''' <remarks>
    ''' sȃfBA^Cv̏ꍇA󔒂Ԃ܂B
    ''' </remarks>
    Public Function GetMediaTypeName(ByVal GUIDStr As String) As String

        Dim ss As String = NormalizeGUIDString(GUIDStr)
        Dim name As String = ""
        Select Case ss

            'W[^Cv
            Case MediaTypeGUID.MEDIATYPE_Video : name = "[Video]"
            Case MediaTypeGUID.MEDIATYPE_Audio : name = "[Audio]"
            Case MediaTypeGUID.MEDIATYPE_Text : name = "[Text]"
            Case MediaTypeGUID.MEDIATYPE_Midi : name = "[Midi]"
            Case MediaTypeGUID.MEDIATYPE_Stream : name = "[Stream]"
            Case MediaTypeGUID.MEDIATYPE_Interleaved : name = "[Interleaved]"
            Case MediaTypeGUID.MEDIATYPE_File : name = "[File]"
            Case MediaTypeGUID.MEDIATYPE_ScriptCommand : name = "[ScriptCommand]"
            Case MediaTypeGUID.MEDIATYPE_AUXLine21Data : name = "[AUXLine21Data]"
            Case MediaTypeGUID.MEDIATYPE_VBI : name = "[VBI]"
            Case MediaTypeGUID.MEDIATYPE_Timecode : name = "[Timecode]"
            Case MediaTypeGUID.MEDIATYPE_LMRT : name = "[LMRT]"
            Case MediaTypeGUID.MEDIATYPE_URL_STREAM : name = "[URL_STREAM]"

                'Tu^Cv
            Case MediaTypeGUID.MEDIASUBTYPE_None : name = "[None]"
            Case MediaTypeGUID.MEDIASUBTYPE_CLPL : name = "[CLPL]"
            Case MediaTypeGUID.MEDIASUBTYPE_YUYV : name = "[YUYV]"
            Case MediaTypeGUID.MEDIASUBTYPE_IYUV : name = "[IYUV]"
            Case MediaTypeGUID.MEDIASUBTYPE_YVU9 : name = "[YVU9]"
            Case MediaTypeGUID.MEDIASUBTYPE_Y411 : name = "[Y411]"
            Case MediaTypeGUID.MEDIASUBTYPE_Y41P : name = "[Y41P]"
            Case MediaTypeGUID.MEDIASUBTYPE_YUY2 : name = "[YUY2]"
            Case MediaTypeGUID.MEDIASUBTYPE_YVYU : name = "[YVYU]"
            Case MediaTypeGUID.MEDIASUBTYPE_UYVY : name = "[UYVY]"
            Case MediaTypeGUID.MEDIASUBTYPE_Y211 : name = "[Y211]"
            Case MediaTypeGUID.MEDIASUBTYPE_CLJR : name = "[CLJR]"
            Case MediaTypeGUID.MEDIASUBTYPE_IF09 : name = "[IF09]"
            Case MediaTypeGUID.MEDIASUBTYPE_CPLA : name = "[CPLA]"
            Case MediaTypeGUID.MEDIASUBTYPE_MJPG : name = "[MJPG]"
            Case MediaTypeGUID.MEDIASUBTYPE_TVMJ : name = "[TVMJ]"
            Case MediaTypeGUID.MEDIASUBTYPE_WAKE : name = "[WAKE]"
            Case MediaTypeGUID.MEDIASUBTYPE_CFCC : name = "[CFCC]"
            Case MediaTypeGUID.MEDIASUBTYPE_IJPG : name = "[IJPG]"
            Case MediaTypeGUID.MEDIASUBTYPE_Plum : name = "[Plum]"
            Case MediaTypeGUID.MEDIASUBTYPE_DVSD : name = "[DVSD]"
            Case MediaTypeGUID.MEDIASUBTYPE_MDVF : name = "[MDVF]"
            Case MediaTypeGUID.MEDIASUBTYPE_RGB1 : name = "[RGB1]"
            Case MediaTypeGUID.MEDIASUBTYPE_RGB4 : name = "[RGB4]"
            Case MediaTypeGUID.MEDIASUBTYPE_RGB8 : name = "[RGB8]"
            Case MediaTypeGUID.MEDIASUBTYPE_RGB565 : name = "[RGB565]"
            Case MediaTypeGUID.MEDIASUBTYPE_RGB555 : name = "[RGB555]"
            Case MediaTypeGUID.MEDIASUBTYPE_RGB24 : name = "[RGB24]"
            Case MediaTypeGUID.MEDIASUBTYPE_RGB32 : name = "[RGB32]"
            Case MediaTypeGUID.MEDIASUBTYPE_ARGB1555 : name = "[ARGB1555]"
            Case MediaTypeGUID.MEDIASUBTYPE_ARGB4444 : name = "[ARGB4444]"
            Case MediaTypeGUID.MEDIASUBTYPE_ARGB32 : name = "[ARGB32]"
            Case MediaTypeGUID.MEDIASUBTYPE_A2R10G10B10 : name = "[A2R10G10B10]"
            Case MediaTypeGUID.MEDIASUBTYPE_A2B10G10R10 : name = "[A2B10G10R10]"
            Case MediaTypeGUID.MEDIASUBTYPE_AYUV : name = "[AYUV]"
            Case MediaTypeGUID.MEDIASUBTYPE_AI44 : name = "[AI44]"
            Case MediaTypeGUID.MEDIASUBTYPE_IA44 : name = "[IA44]"
            Case MediaTypeGUID.MEDIASUBTYPE_YV12 : name = "[YV12]"
            Case MediaTypeGUID.MEDIASUBTYPE_NV12 : name = "[NV12]"
            Case MediaTypeGUID.MEDIASUBTYPE_IMC1 : name = "[IMC1]"
            Case MediaTypeGUID.MEDIASUBTYPE_IMC2 : name = "[IMC2]"
            Case MediaTypeGUID.MEDIASUBTYPE_IMC3 : name = "[IMC3]"
            Case MediaTypeGUID.MEDIASUBTYPE_IMC4 : name = "[IMC4]"
            Case MediaTypeGUID.MEDIASUBTYPE_S340 : name = "[S340]"
            Case MediaTypeGUID.MEDIASUBTYPE_S342 : name = "[S342]"
            Case MediaTypeGUID.MEDIASUBTYPE_I420 : name = "[I420]"
            Case MediaTypeGUID.MEDIASUBTYPE_Overlay : name = "[Overlay]"
            Case MediaTypeGUID.MEDIASUBTYPE_MPEGPacket : name = "[MPEGPacket]"
            Case MediaTypeGUID.MEDIASUBTYPE_MPEG1Payload : name = "[MPEG1Payload]"
            Case MediaTypeGUID.MEDIASUBTYPE_MPEG1AudioPayload : name = "[MPEG1AudioPayload]"
            Case MediaTypeGUID.MEDIASUBTYPE_MPEG1SystemStream : name = "[MPEG1SystemStream]"
            Case MediaTypeGUID.MEDIASUBTYPE_MPEG1VideoCD : name = "[MPEG1VideoCD]"
            Case MediaTypeGUID.MEDIASUBTYPE_MPEG1Video : name = "[MPEG1Video]"
            Case MediaTypeGUID.MEDIASUBTYPE_MPEG1Audio : name = "[MPEG1Audio]"
            Case MediaTypeGUID.MEDIASUBTYPE_Avi : name = "[Avi]"
            Case MediaTypeGUID.MEDIASUBTYPE_Asf : name = "[Asf]"
            Case MediaTypeGUID.MEDIASUBTYPE_QTMovie : name = "[QTMovie]"
            Case MediaTypeGUID.MEDIASUBTYPE_Rpza : name = "[Rpza]"
            Case MediaTypeGUID.MEDIASUBTYPE_Smc : name = "[Smc]"
            Case MediaTypeGUID.MEDIASUBTYPE_Rle : name = "[Rle]"
            Case MediaTypeGUID.MEDIASUBTYPE_Jpeg : name = "[Jpeg]"
            Case MediaTypeGUID.MEDIASUBTYPE_PCMAudio_Obsolete : name = "[PCMAudio_Obsolete]"
            Case MediaTypeGUID.MEDIASUBTYPE_PCM : name = "[PCM]"
            Case MediaTypeGUID.MEDIASUBTYPE_WAVE : name = "[WAVE]"
            Case MediaTypeGUID.MEDIASUBTYPE_AU : name = "[AU]"
            Case MediaTypeGUID.MEDIASUBTYPE_AIFF : name = "[AIFF]"
            Case MediaTypeGUID.MEDIASUBTYPE_dvsd2 : name = "[dvsd2]"
            Case MediaTypeGUID.MEDIASUBTYPE_dvhd : name = "[dvhd]"
            Case MediaTypeGUID.MEDIASUBTYPE_dvsl : name = "[dvsl]"
            Case MediaTypeGUID.MEDIASUBTYPE_dv25 : name = "[dv25]"
            Case MediaTypeGUID.MEDIASUBTYPE_dv50 : name = "[dv50]"
            Case MediaTypeGUID.MEDIASUBTYPE_dvh1 : name = "[dvh1]"
            Case MediaTypeGUID.MEDIASUBTYPE_Line21_BytePair : name = "[Line21_BytePair]"
            Case MediaTypeGUID.MEDIASUBTYPE_Line21_GOPPacket : name = "[Line21_GOPPacket]"
            Case MediaTypeGUID.MEDIASUBTYPE_Line21_VBIRawData : name = "[Line21_VBIRawData]"
            Case MediaTypeGUID.MEDIASUBTYPE_TELETEXT : name = "[TELETEXT]"

            Case Else
                name = ""   'sȃfBA^Cv̏ꍇA󔒂Ԃ

        End Select

        Return name
    End Function

    ''' <summary>
    ''' fBA^CvGUID킩Ղ̂擾܂B
    ''' </summary>
    ''' <param name="GuidType">GUID</param>
    ''' <returns>W[^Cv^Tu^Cv̖</returns>
    ''' <remarks>
    ''' sȃfBA^Cv̏ꍇA󔒂Ԃ܂B
    ''' </remarks>
    Public Function GetMediaTypeName(ByVal GuidType As Guid) As String
        Return GetMediaTypeName(GuidType.ToString)
    End Function

#End Region

#Region "rfI_֌W"

    ''' <summary>
    ''' rfI_̊gk萔łB
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum RendererScale    'gk
        ''' <summary>gk܂B</summary>
        None = 0
        ''' <summary>cۂĊgk܂B</summary>
        KeepAspect = 1
        ''' <summary>̈ŜɊgk܂B</summary>
        Full = 2
    End Enum

    ''' <summary>
    ''' w肳ꂽRg[œ悪Đ悤ɃrfI_ݒ肵܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <param name="Owner">悪ĐRg[</param>
    ''' <param name="Zoom">gk`</param>
    ''' <remarks></remarks>
    Public Sub SetVideoRendererOwner(ByVal Grp As IGraphBuilder, ByVal Owner As Control, ByVal Zoom As RendererScale)

        '`FbN
        If Grp Is Nothing Then Exit Sub

        Try
            '_̃I[i[ݒ
            Dim sz As Size = Owner.ClientSize
            SetVideoRendererOwner(Grp, Owner.Handle, sz, Zoom)

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "rfI_̐ݒɎs܂B")
        End Try

    End Sub

    ''' <summary>
    ''' w肳ꂽEBhEœ悪Đ悤ɃrfI_ݒ肵܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <param name="Owner">ĐEBhẼnh</param>
    ''' <param name="OwnerSize">EBhẼTCY</param>
    ''' <param name="Zoom">gk`</param>
    ''' <remarks></remarks>
    Public Sub SetVideoRendererOwner(ByVal Grp As IGraphBuilder, ByVal Owner As IntPtr, ByVal OwnerSize As Size, ByVal Zoom As RendererScale)

        Try

            '`FbN
            If Grp Is Nothing Then Throw New DSException("Ot쐬Ă܂B")
            If (OwnerSize.Width = 0) Or (OwnerSize.Height = 0) Then Exit Sub 'Throw New DSException("Đ̈̃TCYsłB")

            'IVideoWindowC^[tF[X擾
            Dim vw As IVideoWindow = Nothing
            vw = TryCast(Grp, IVideoWindow)
            If vw Is Nothing Then Exit Sub

            '摜TCY擾
            Dim vsz As Size
            Try
                vsz = GetVideoSize(Grp)
            Catch ex As Exception
                'rfITCY擾łȂꍇA𒆎~B
                Return
            End Try
            If (vsz.Width = 0) Or (vsz.Height = 0) Then Throw New DSException("rfITCYsłB")

            'ĐʒuƃTCY
            Dim pos As Point, sz As Size
            Select Case Zoom
                Case RendererScale.None 'gkȂ
                    sz = vsz

                Case RendererScale.KeepAspect   'cۂĊgk
                    sz.Width = OwnerSize.Width
                    sz.Height = CInt(vsz.Height * sz.Width / vsz.Width)
                    If sz.Height > OwnerSize.Height Then
                        sz.Height = OwnerSize.Height
                        sz.Width = CInt(vsz.Width * sz.Height / vsz.Height)
                    End If

                Case RendererScale.Full 'ŜɊgkȂ
                    sz = OwnerSize

                Case Else
                    Exit Sub
            End Select
            pos.X = (OwnerSize.Width - sz.Width) \ 2
            pos.Y = (OwnerSize.Height - sz.Height) \ 2

            'I[i[ݒ
            vw.put_Owner(Owner)

            'EBhEX^CύX
            vw.put_WindowStyle(&H40000000)

            'ʒuύX
            vw.SetWindowPosition(pos.X, pos.Y, sz.Width, sz.Height)

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "rfI_̐ݒɎs܂B")

        Finally


        End Try

    End Sub

    ''' <summary>
    ''' rfI_̃bZ[Ww肵Rg[Ŏ󂯂悤ɂ܂B
    ''' ɂrfI_EBhEł̃}EXɔł悤ɂȂ܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <param name="Owner">Cxg𔭐Rg[</param>
    ''' <remarks>ClickCxg͔܂BMouseDownCxggpĉB</remarks>
    Public Sub SetVideoRendererEventOwner(ByVal Grp As IGraphBuilder, ByVal Owner As Control)

        Try
            '_̃I[i[ݒ
            SetVideoRendererEventOwner(Grp, Owner.Handle)

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "rfI_̐ݒɎs܂B")
        End Try

    End Sub

    ''' <summary>
    ''' rfI_̃bZ[Ww肵Rg[Ŏ󂯂悤ɂ܂B
    ''' ɂrfI_EBhEł̃}EXɔł悤ɂȂ܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <param name="Owner">Cxg󂯎EBhẼnh</param>
    ''' <remarks>ClickCxg͔܂BMouseDownCxggpĉB</remarks>
    Public Sub SetVideoRendererEventOwner(ByVal Grp As IGraphBuilder, ByVal Owner As IntPtr)

        Try
            '`FbN
            If Grp Is Nothing Then Throw New DSException("Ot쐬Ă܂B")

            'IVideoWindowC^[tF[X擾
            Dim vw As IVideoWindow = Nothing
            vw = TryCast(Grp, IVideoWindow)
            If vw Is Nothing Then Exit Sub

            'bZ[W󂯎EBhEݒ
            vw.put_MessageDrain(Owner)

        Catch ex As DSException
            Throw
        Catch ex As Exception
            Throw New DSException(ex, "rfI_̐ݒɎs܂B")
        End Try

    End Sub

#End Region

#Region "vpeBy[W\"

    ''' <summary>
    ''' tB^̓s̃vpeBy[W\܂B
    ''' </summary>
    ''' <param name="FilterObject">tB^̓s</param>
    ''' <param name="WindowHandle">vpeBy[W_CAÕI[i[EBhEnh</param>
    ''' <param name="Caption">_CAÕ^Cg</param>
    ''' <returns>vpeBy[WJꂽꍇFalseAJȂꍇTrue</returns>
    ''' <remarks></remarks>
    Public Function OpenPropertyDialog(ByVal FilterObject As Object, ByVal WindowHandle As IntPtr, Optional ByVal Caption As String = "vpeB") As Boolean

        Dim ca As CAUUID
        Try
            'ISpecifyPropertyPagesC^[tF[X擾
            Dim sp As ISpecifyPropertyPages
            sp = TryCast(FilterObject, ISpecifyPropertyPages)
            If sp Is Nothing Then
                'vpeBy[W͂Ȃ
                Return True
            End If

            'vpeBy[W擾
            sp.GetPages(ca)

            'vpeBy[W\
            Win32API.OleCreatePropertyFrame( _
                WindowHandle, 0, 0, _
                Caption, 1, _
                FilterObject, ca.cElems, ca.pElems, 0, 0, Nothing)

        Catch ex As Exception
            Throw New DSException(ex, "vpeBy[W̕\Ɏs܂B")

        Finally

            'n
            If ca.pElems <> IntPtr.Zero Then Marshal.FreeCoTaskMem(ca.pElems)

        End Try

        Return False
    End Function

#End Region

#Region "e񋓃ASY"

#Region "o^ς݃tB^񋓃ASY"

    ''' <summary>
    ''' tB^񋓃ASYp̃fQ[głB
    ''' </summary>
    ''' <param name="Mon">jJ</param>
    ''' <param name="PropertyBag">vpeBobO</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks></remarks>
    Public Delegate Function DelegateEnumFilters(ByRef Mon As ComTypes.IMoniker, ByVal PropertyBag As IPropertyBag, ByVal Param As Object) As Boolean

    ''' <summary>
    ''' tB^񋓂̃ASY񋟂܂B
    ''' w肳ꂽJeS̃tB^񋓂AetB^ɃfQ[gĂяo܂B
    ''' </summary>
    ''' <param name="Category">񋓂JeSGUID</param>
    ''' <param name="DelegateFunc">񋓂ꂽtB^fQ[g</param>
    ''' <param name="Param">fQ[g֐ɓn</param>
    ''' <remarks></remarks>
    Public Sub EnumFiltersAlgorithm(ByVal Category As String, ByVal DelegateFunc As DelegateEnumFilters, ByVal Param As Object)
        EnumFiltersAlgorithm(New Guid(Category), DelegateFunc, Param)
    End Sub

    ''' <summary>
    ''' tB^񋓂̃ASY񋟂܂B
    ''' w肳ꂽJeS̃tB^񋓂AetB^ɃfQ[gĂяo܂B
    ''' </summary>
    ''' <param name="Category">񋓂JeSGUID</param>
    ''' <param name="DelegateFunc">񋓂ꂽtB^fQ[g</param>
    ''' <param name="Param">fQ[g֐ɓn</param>
    ''' <remarks></remarks>
    Public Sub EnumFiltersAlgorithm(ByVal Category As Guid, ByVal DelegateFunc As DelegateEnumFilters, ByVal Param As Object)

        Dim emon As ComTypes.IEnumMoniker = Nothing
        Dim devenum As ICreateDevEnum = Nothing
        Try

            'VXefoCX񋓎q̃^Cv
            Dim devenumtype As Type
            devenumtype = Type.GetTypeFromCLSID(New Guid(ClassGUID.CLSID_SystemDeviceEnum))

            'VXefoCX񋓎q̃CX^X쐬
            Dim devenumobj As Object
            devenumobj = Activator.CreateInstance(devenumtype)

            'ICreateDevEnumC^[tF[X擾
            devenum = CType(devenumobj, ICreateDevEnum)
            devenumobj = Nothing

            'EnumMoniker̍쐬
            devenum.CreateClassEnumerator(Category, emon, 0)

            '
            Dim mon(0) As ComTypes.IMoniker
            Dim fc As IntPtr
            Dim rc As Boolean = False
            Do While (emon.Next(1, mon, fc) = 0) And (rc = False)

                'vpeBobOւ̃oCh
                Dim propbagobj As Object = Nothing
                mon(0).BindToStorage(Nothing, Nothing, New Guid(InterfaceGUID.IID_IPropertyBag), propbagobj)
                Dim propbag As IPropertyBag
                propbag = CType(propbagobj, IPropertyBag)
                propbagobj = Nothing

                'fQ[gĂяo
                rc = DelegateFunc(mon(0), propbag, Param)

                'vpeBobỎ
                Marshal.ReleaseComObject(propbag)
                propbag = Nothing

                '񋓂jJ̉
                If Not mon(0) Is Nothing Then
                    Marshal.ReleaseComObject(mon(0))
                    mon(0) = Nothing
                End If
            Loop

        Catch ex As Exception
            Throw New DSException(ex, "tB^̗񋓂Ɏs܂BCategoryGUID={0}", Category)

        Finally
            If emon IsNot Nothing Then Marshal.ReleaseComObject(emon)
            If devenum IsNot Nothing Then Marshal.ReleaseComObject(devenum)

        End Try

    End Sub

#End Region

#Region "s񋓃ASY"

    ''' <summary>
    ''' s񋓃ASYp̃fQ[głB
    ''' </summary>
    ''' <param name="Pin">񋓂ꂽs</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks></remarks>
    Public Delegate Function DelegateEnumPins(ByRef Pin As IPin, ByVal Param As Object) As Boolean

    ''' <summary>
    ''' s񋓂̃ASY񋟂܂B
    ''' w肳ꂽtB^̃s񋓂AesɃfQ[gĂяo܂B
    ''' </summary>
    ''' <param name="Filter">tB^</param>
    ''' <param name="DelegateFunc">񋓂ꂽsfQ[g</param>
    ''' <param name="Param">fQ[gɓn</param>
    ''' <remarks></remarks>
    Public Sub EnumPinsAlgorithm(ByVal Filter As IBaseFilter, ByVal DelegateFunc As DelegateEnumPins, ByVal Param As Object)

        Dim epin As IEnumPins = Nothing
        Dim pin As IPin = Nothing
        Try

            's񋓎q擾
            Filter.EnumPins(epin)

            '
            Dim fc As Integer
            Do While epin.Next(1, pin, fc) = 0
                If fc = 0 Then Exit Do

                'fQ[gĂяo
                DelegateFunc(pin, Param)

                '񋓂s̉
                If pin IsNot Nothing Then
                    Marshal.ReleaseComObject(pin)
                    pin = Nothing
                End If
            Loop

        Catch ex As Exception
            Throw New DSException(ex, "s̗񋓂Ɏs܂B")

        Finally
            If epin IsNot Nothing Then Marshal.ReleaseComObject(epin)
            If pin IsNot Nothing Then Marshal.ReleaseComObject(pin)

        End Try

    End Sub

#End Region

#Region "tH[}bg񋓃ASY"

    ''' <summary>
    ''' s񋓃ASYp̃fQ[głB
    ''' </summary>
    ''' <param name="MediaType">fBA^Cv</param>
    ''' <param name="Param"></param>
    ''' <returns>񋓂IꍇTrueApꍇFalse</returns>
    ''' <remarks></remarks>
    Public Delegate Function DelegateEnumFormat(ByRef MediaType As AM_MEDIA_TYPE, ByVal Param As Object) As Boolean

    ''' <summary>
    ''' tH[}bg`񋓂̃ASY񋟂܂B
    ''' w肳ꂽs̃tH[}bg`񋓂AetH[}bg`ɃfQ[gĂяo܂B
    ''' </summary>
    ''' <param name="Pin">s</param>
    ''' <param name="DelegateFunc">񋓂ꂽtH[}bg`fQ[g</param>
    ''' <param name="Param">fQ[gɓn</param>
    ''' <remarks></remarks>
    Public Sub EnumFormatAlgorithm(ByVal Pin As IPin, ByVal DelegateFunc As DelegateEnumFormat, ByVal Param As Object)

        Dim dataptr As IntPtr = IntPtr.Zero
        Dim mt As AM_MEDIA_TYPE = Nothing
        Try

            'IAMStreamConfigC^[tF[X̎擾
            If Pin Is Nothing Then Exit Sub
            Dim asc As IAMStreamConfig = TryCast(Pin, IAMStreamConfig)
            If asc Is Nothing Then Throw New DSException("̃foCX̓tH[}bg񋓂ł܂B")

            'tH[}bg擾
            Dim fcnt As Integer = 0
            Dim ssz As Integer = 0
            asc.GetNumberOfCapabilities(fcnt, ssz)

            'f[^p̈m
            dataptr = Marshal.AllocHGlobal(ssz)

            '
            Dim flg As Boolean
            For x As Integer = 0 To fcnt - 1

                'xԖڂ̃tH[}bg擾
                asc.GetStreamCaps(x, mt, dataptr)

                'fQ[gĂяo
                flg = DelegateFunc(mt, Param)

                '
                If Not mt Is Nothing Then DeleteMediaType(mt)

                If flg Then Exit For
            Next

        Catch ex As DSException
            Throw

        Catch ex As Exception
            Throw New DSException(ex, "tH[}bg̗񋓂Ɏs܂B")

        Finally
            If dataptr <> IntPtr.Zero Then Marshal.FreeHGlobal(dataptr)
            If Not mt Is Nothing Then DeleteMediaType(mt)

        End Try

    End Sub

#End Region

#End Region

End Module
